VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' Playlist Manager
' Zum Lesen und Schreiben verschiedener Playlistformate
'
' Arne Elster 2009
'
' Auch noch Plugins fr entwickeln?


Private Type File
    path                As String
    Title               As String
    Duration            As Long
End Type

Private m_udtFiles()    As File
Private m_lngFilesSize  As Long
Private m_lngFileCount  As Long

Private m_clsHandlers() As IPlaylist
Private m_lngHandlerCnt As Long

Public Property Get HandlerCount() As Long
    HandlerCount = m_lngHandlerCnt
End Property

Public Sub AddHandler(ByVal clsHandler As IPlaylist)
    ReDim Preserve m_clsHandlers(m_lngHandlerCnt) As IPlaylist
    Set m_clsHandlers(m_lngHandlerCnt) = clsHandler
    m_lngHandlerCnt = m_lngHandlerCnt + 1
End Sub

Public Property Get HandlerDescription(ByVal i As Long) As String
    HandlerDescription = m_clsHandlers(i).Description
End Property

Public Property Get HandlerExtensions(ByVal i As Long) As String()
    HandlerExtensions = m_clsHandlers(i).Extensions
End Property

Public Function SavePlaylist(ByVal strFile As String) As Boolean
    Dim strExt As String: strExt = GetExtension(strFile)
    Dim strExts() As String
    Dim i As Long
    Dim j As Long
    
    For i = 0 To HandlerCount - 1
        strExts = HandlerExtensions(i)
        For j = 0 To UBound(strExts)
            If StrComp(strExts(j), strExt, vbTextCompare) = 0 Then
                SavePlaylist = m_clsHandlers(i).WritePlaylist(Me, strFile)
                Exit For
            End If
        Next
    Next
End Function

Public Function OpenPlaylist(ByVal strFile As String) As Boolean
    Dim strExt As String: strExt = GetExtension(strFile)
    Dim strExts() As String
    Dim i As Long
    Dim j As Long
    
    For i = 0 To HandlerCount - 1
        strExts = HandlerExtensions(i)
        For j = 0 To UBound(strExts)
            If StrComp(strExts(j), strExt, vbTextCompare) = 0 Then
                OpenPlaylist = m_clsHandlers(i).ReadPlaylist(Me, strFile)
                Exit For
            End If
        Next
    Next
End Function

Public Property Get FileCount() As Long
    FileCount = m_lngFileCount
End Property

Public Property Get FilePath(ByVal i As Long) As String
    FilePath = m_udtFiles(i).path
End Property

Public Property Let FilePath(ByVal i As Long, ByVal strValue As String)
    m_udtFiles(i).path = strValue
End Property

Public Property Get FileTitle(ByVal i As Long) As String
    FileTitle = m_udtFiles(i).Title
End Property

Public Property Let FileTitle(ByVal i As Long, ByVal strValue As String)
    m_udtFiles(i).Title = strValue
End Property

Public Property Get FileDuration(ByVal i As Long) As Long
    FileDuration = m_udtFiles(i).Duration
End Property

Public Property Let FileDuration(ByVal i As Long, ByVal lngValue As Long)
    m_udtFiles(i).Duration = lngValue
End Property

Public Sub AddFile( _
    ByVal strPath As String, _
    ByVal strTitle As String, _
    ByVal lngSeconds As Long _
)

    If m_lngFileCount = m_lngFilesSize Then
        m_lngFilesSize = m_lngFilesSize + 50
        ReDim Preserve m_udtFiles(m_lngFilesSize - 1)
    End If
    With m_udtFiles(m_lngFileCount)
        .Title = strTitle
        .path = strPath
        .Duration = lngSeconds
    End With
    m_lngFileCount = m_lngFileCount + 1
End Sub

Public Sub Clear()
    Erase m_udtFiles
    m_lngFileCount = 0
    m_lngFilesSize = 0
End Sub

Private Sub Class_Initialize()
    AddHandler New PlaylistM3U
End Sub
