VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PluginManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_clsPlugins        As PluginLoader
Private m_clsInstances()    As IPlugin
Private m_lngInstCount      As Long

Public Property Get Count() As Long
    Count = m_lngInstCount
End Property

Public Property Get Plugin(ByVal index As Long) As IPlugin
    Set Plugin = m_clsInstances(index)
End Property

Private Sub Class_Initialize()
    Set m_clsPlugins = New PluginLoader

    With m_clsPlugins
        .RecursiveSearch = True
        .PluginPath = AddSlash(App.path)
        Set .Interface = New MonoPluginLib.IPlugin
    End With
    
    RefreshPluginList
End Sub

Public Sub Add(ByVal cls As IPlugin)
    ReDim Preserve m_clsInstances(m_lngInstCount) As IPlugin
    Set m_clsInstances(m_lngInstCount) = cls
    m_lngInstCount = m_lngInstCount + 1
End Sub

Private Sub RefreshPluginList()
    Dim i As Long
    
    m_clsPlugins.FindPlugins
    If m_clsPlugins.PluginCount > 0 Then
        ReDim m_clsInstances(m_clsPlugins.PluginCount - 1) As IPlugin
        For i = 0 To m_clsPlugins.PluginCount - 1
            Set m_clsInstances(i) = m_clsPlugins.CreatePlugin(i)
        Next
        m_lngInstCount = m_clsPlugins.PluginCount
    End If
End Sub
