VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PluginSession"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' Interface zur Steuerung von Monoton fr Plugins
'
' Arne Elster 2009


Implements Session
Implements Playback
Implements Playlists


'#####################################################
'#####################################################
' PLAYLISTS


Private Property Get Playlists_ActivePlaylist() As MonoPluginLib.Playlist
    Set Playlists_ActivePlaylist = Playlists_Item(MonoMain.ActivePlaylist.index)
End Property

Private Property Get Playlists_Count() As Long
    Playlists_Count = MonoMain.PlaylistCount
End Property

Private Function Playlists_Create() As MonoPluginLib.Playlist
    MonoMain.CreateNewPlaylist False
End Function

Private Property Get Playlists_Item(ByVal idx As Long) As MonoPluginLib.Playlist
    If idx >= 0 And idx < Playlists_Count Then
        Dim cls As PluginPlaylist
        Set cls = New PluginPlaylist
        
        cls.Init idx, MonoMain.GetActualPlaylistIndex(idx + 1)
        Set Playlists_Item = cls
    End If
End Property

Private Sub Playlists_Remove(ByVal index As Long)
    MonoMain.DeletePlaylist index
End Sub



'#####################################################
'#####################################################
' PLAYBACK


Private Property Get Playback_Current() As MonoPluginLib.PlaylistItem
    If MonoMain.PlayingIndex > -1 Then
        Dim cls As PluginPlaylistItem
        Set cls = New PluginPlaylistItem
        
        cls.Init MonoMain.GetVirtualPlaylistIndex(MonoMain.PlayingListIndex), _
                 MonoMain.PlayingListIndex, MonoMain.PlayingIndex
        
        Set Playback_Current = cls
    End If
End Property

Private Property Get Playback_Duration() As Long
    Playback_Duration = MonoMain.CurrentDuration
End Property

Private Property Get Playback_Position() As Long
    Playback_Position = MonoMain.CurrentPosition
End Property

Private Function Playback_NewStreamFromExt(ByVal strExt As String) As MonoPluginLib.IPluginStream
    Set Playback_NewStreamFromExt = Factory.GetNewStreamForExt(strExt)
End Function

Private Sub Playback_NextItem()
    MonoMain.PlayNext False, True
End Sub

Private Sub Playback_PausePlay()
    MonoMain.PausePlay
End Sub

Private Sub Playback_Play(ByVal Item As MonoPluginLib.PlaylistItem)
    MonoMain.PlayIndex MonoMain.GetActualPlaylistIndex(Item.PlaylistIndex + 1), _
                       Item.index
End Sub

Private Sub Playback_PreviousItem()
    MonoMain.PlayNext True, True
End Sub

Private Sub Playback_StopPlay()
    MonoMain.StopPlay True
End Sub

Private Property Get Playback_FileOpened() As Boolean
    Playback_FileOpened = MonoMain.FileOpened
End Property

Private Property Get Playback_IsPaused() As Boolean
    Playback_IsPaused = MonoMain.Status = DSO_PAUSING
End Property

Private Property Get Playback_IsPlaying() As Boolean
    Playback_IsPlaying = MonoMain.Status = DSO_PLAYING
End Property



'#####################################################
'#####################################################
' SESSION



Private Property Get Session_DSP() As MonoPluginLib.DSP
    Set Session_DSP = DSP
End Property

Private Sub Session_MagnetizeWindow(ByVal hwnd As Long)
    MagneticWnd.AddWindow hwnd, Session_MainHWND
End Sub

Private Property Get Session_Playback() As MonoPluginLib.Playback
    Set Session_Playback = Me
End Property

Private Property Get Session_Playlists() As MonoPluginLib.Playlists
    Set Session_Playlists = Me
End Property

Private Sub Session_RegisterEventCallback(ByVal cls As MonoPluginLib.IEventCallback)
    AddEventCallback cls
End Sub

Private Sub Session_RemoveEventCallback(ByVal cls As MonoPluginLib.IEventCallback)
    RemoveEventCallback cls
End Sub

Private Property Get Session_Tools() As MonoPluginLib.Tools
    Set Session_Tools = Tools
End Property

Private Sub Session_UnmagnetizeWindow(ByVal hwnd As Long)
    MagneticWnd.RemoveWindow hwnd
End Sub

Private Property Get Session_MainHWND() As Long
    Session_MainHWND = MonoMain.hwnd
End Property
