VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StreamTags"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_colInfos  As Collection
Private m_colTags   As Collection
Private m_blnChanged As Boolean

Public Property Get Changed() As Boolean
    Changed = m_blnChanged
End Property

Public Property Get InfoCount() As Long
    InfoCount = m_colInfos.Count
End Property

Public Property Get info(ByVal idx As Long) As StringPair
    Set info = m_colInfos(idx)
End Property

Public Property Get TagCount() As Long
    TagCount = m_colTags.Count
End Property

Public Property Get Tag(ByVal idx) As StringPair
    Set Tag = m_colTags(idx)
End Property

Public Property Get TagExists(ByVal idx As String) As Boolean
    Dim i As Long
    
    For i = 1 To TagCount
        If StrComp(idx, Tag(i).Key, vbTextCompare) = 0 Then
            TagExists = True
            Exit Property
        End If
    Next
End Property

Public Sub AddInfo(ByVal strKey As String, ByVal strValue As String)
    AddToCollection m_colInfos, strKey, strValue
End Sub

Public Sub AddTag(ByVal strKey As String, ByVal strValue As String)
    AddToCollection m_colTags, strKey, strValue
End Sub

Public Sub RemoveTag(ByVal strKey As String)
    m_colTags.Remove strKey
    m_blnChanged = True
End Sub

Private Sub AddToCollection( _
    ByVal col As Collection, _
    ByVal strKey As String, _
    ByVal strValue As String _
)

    Dim pair As New StringPair
    pair.Key = strKey
    pair.value = strValue
    pair.Changed = False
    col.Add pair, strKey
End Sub

Private Sub Class_Initialize()
    Set m_colInfos = New Collection
    Set m_colTags = New Collection
End Sub
