Attribute VB_Name = "BrowseForFolder"
Option Explicit

' BrowseForFolder: http://pscode.com/vb/scripts/ShowCode.asp?txtCodeId=49326&lngWId=1

Private Declare Function SHSimpleIDListFromPath Lib "shell32.dll" _
Alias "#162" ( _
    ByVal szPath As String _
) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" ( _
    ByVal pidList As Long, _
    ByVal lpBuffer As String _
) As Long

Private Declare Function SHBrowseForFolder Lib "shell32.dll" ( _
    lpbi As BrowseInfo _
) As Long

Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
    ByVal hMem As Long _
)

Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" ( _
    ByVal hwndOwner As Long, _
    ByVal nFolder As Long, _
    pidl As ITEMIDLIST _
) As Long

Private Declare Sub OleInitialize Lib "ole32.dll" ( _
    pvReserved As Any _
)

Private Declare Function PathIsDirectory Lib "shlwapi.dll" _
Alias "PathIsDirectoryA" ( _
    ByVal pszPath As String _
) As Long

Private Declare Function SendMessage Lib "user32.dll" _
Alias "SendMessageA" ( _
    ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As String _
) As Long

Private Declare Function SendMessage2 Lib "user32.dll" _
Alias "SendMessageA" ( _
    ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long _
) As Long

Private Declare Function GetVersionEx Lib "kernel32" _
Alias "GetVersionExA" ( _
    lpVersionInformation As OSVERSIONINFO _
) As Long

Private Const MAX_PATH              As Long = 260

Private Type SH_ITEM_ID
    cb                              As Long
    abID                            As Byte
End Type

Private Type ITEMIDLIST
    mkid                            As SH_ITEM_ID
End Type

Private Type BrowseInfo
    hwndOwner                       As Long
    pidlRoot                        As Long
    pszDisplayName                  As String
    lpszTitle                       As String
    ulFlags                         As Long
    lpfnCallback                    As Long
    lParam                          As Long
    iImage                          As Long
End Type

Private Type OSVERSIONINFO
  dwOSVersionInfoSize               As Long
  dwMajorVersion                    As Long
  dwMinorVersion                    As Long
  dwBuildNumber                     As Long
  dwPlatformId                      As Long
  szCSDVersion                      As String * 128
End Type

Public Enum ROOTDIR_ID
    ROOTDIR_CUSTOM = -1
    ROOTDIR_ALL = &H0
    ROOTDIR_MY_COMPUTER = &H11
    ROOTDIR_DRIVES = &H11
    ROOTDIR_ALL_NETWORK = &H12
    ROOTDIR_NETWORK_COMPUTERS = &H3D
    ROOTDIR_WORKGROUP = &H3D
    ROOTDIR_USER = &H28
    ROOTDIR_USER_DESKTOP = &H10
    ROOTDIR_USER_MY_DOCUMENTS = &H5
    ROOTDIR_USER_START_MENU = &HB
    ROOTDIR_USER_START_MENU_PROGRAMS = &H2
    ROOTDIR_USER_START_MENU_PROGRAMS_STARTUP = &H7
    ROOTDIR_COMMON_DESKTOP = &H19
    ROOTDIR_COMMON_DOCUMENTS = &H2E
    ROOTDIR_COMMON_START_MENU = &H16
    ROOTDIR_COMMON_START_MENU_PROGRAMS = &H17
    ROOTDIR_COMMON_START_MENU_PROGRAMS_STARTUP = &H18
    ROOTDIR_WINDOWS = &H24
    ROOTDIR_SYSTEM = &H25
    ROOTDIR_FONTS = &H14
    ROOTDIR_PROGRAM_FILES = &H26
    ROOTDIR_PROGRAM_FILES_COMMON_FILES = &H2B
End Enum

Private Const WM_USER               As Long = &H400
Private Const BFFM_INITIALIZED      As Long = 1
Private Const BFFM_SELCHANGED       As Long = 2
Private Const BFFM_SETSTATUSTEXT    As Long = (WM_USER + 100)
Private Const BFFM_SETSELECTION     As Long = (WM_USER + 102)
Private Const BFFM_SETOKTEXT        As Long = (WM_USER + 105)
Private Const BFFM_ENABLEOK         As Long = (WM_USER + 101)
Private Const BIF_DEFAULT           As Long = &H0
Private Const BIF_RETURNONLYFSDIRS  As Long = &H1
Private Const BIF_DONTGOBELOWDOMAIN As Long = &H2
Private Const BIF_STATUSTEXT        As Long = &H4
Private Const BIF_RETURNFSANCESTORS As Long = &H8
Private Const BIF_EDITBOX           As Long = &H10
Private Const BIF_VALIDATE          As Long = &H20
Private Const BIF_NEWDIALOGSTYLE    As Long = &H40
Private Const BIF_USENEWUI          As Long = &H50
Private Const BIF_BROWSEINCLUDEURLS As Long = &H80
Private Const BIF_UAHINT            As Long = &H100
Private Const BIF_NONEWFOLDERBUTTON As Long = &H200
Private Const BIF_NOTRANSLATETARGETS As Long = &H400
Private Const BIF_BROWSEFORCOMPUTER As Long = &H1000
Private Const BIF_BROWSEFORPRINTER  As Long = &H2000
Private Const BIF_BROWSEINCLUDEFILES As Long = &H4000
Private Const BIF_SHAREABLE         As Long = &H8000

Private m_CurrentDirectory          As String
Private OK_BUTTON_TEXT              As String

Private Function isNT2000XP( _
) As Boolean

    Dim lpv As OSVERSIONINFO
    lpv.dwOSVersionInfoSize = Len(lpv)
    GetVersionEx lpv

    If lpv.dwPlatformId = 2 Then
        isNT2000XP = True
    Else
        isNT2000XP = False
    End If
End Function

Private Function isME2KXP( _
) As Boolean

    Dim lpv As OSVERSIONINFO

    lpv.dwOSVersionInfoSize = Len(lpv)
    GetVersionEx lpv

    If ((lpv.dwPlatformId = 2) And (lpv.dwMajorVersion >= 5)) Or _
       ((lpv.dwPlatformId = 1) And (lpv.dwMajorVersion >= 4) And _
       (lpv.dwMinorVersion >= 90)) Then

        isME2KXP = True
    Else
        isME2KXP = False
    End If
End Function

Private Function GetPIDLFromPath( _
    spath As String _
) As Long

    ' Return the pidl to the path supplied b
    '     y calling the undocumented API #162

    If isNT2000XP Then
        GetPIDLFromPath = SHSimpleIDListFromPath(StrConv(spath, vbUnicode))
    Else
        GetPIDLFromPath = SHSimpleIDListFromPath(spath)
    End If
End Function

Private Function GetSpecialFolderID( _
    ByVal CSIDL As ROOTDIR_ID _
) As Long

    Dim IDL As ITEMIDLIST, R As Long

    R = SHGetSpecialFolderLocation(ByVal 0&, CSIDL, IDL)

    If R = 0 Then
        GetSpecialFolderID = IDL.mkid.cb
    Else
        GetSpecialFolderID = 0
    End If
End Function

Private Function GetAddressOfFunction( _
    zAdd As Long _
) As Long

    GetAddressOfFunction = zAdd
End Function

Private Function BrowseCallbackProc( _
    ByVal hwnd As Long, _
    ByVal uMsg As Long, _
    ByVal lp As Long, _
    ByVal pData As Long _
) As Long

    On Local Error Resume Next

    Dim sBuffer As String

    Select Case uMsg

        Case BFFM_INITIALIZED
            SendMessage hwnd, BFFM_SETSELECTION, 1, m_CurrentDirectory
            If OK_BUTTON_TEXT <> vbNullString Then
                SendMessage2 hwnd, BFFM_SETOKTEXT, 1, StrPtr(OK_BUTTON_TEXT)
            End If

        Case BFFM_SELCHANGED
            sBuffer = Space$(MAX_PATH)
            SHGetPathFromIDList lp, sBuffer
            sBuffer = Left$(sBuffer, InStr(sBuffer, vbNullChar) - 1)

            If Len(sBuffer) = 0 Then
                SendMessage2 hwnd, BFFM_ENABLEOK, 1, 0
                SendMessage hwnd, BFFM_SETSTATUSTEXT, 1, ""
            Else
                SendMessage hwnd, BFFM_SETSTATUSTEXT, 1, sBuffer
            End If

    End Select

BrowseCallbackProc = 0
End Function

Public Function BrowseForFolder( _
    Optional OwnerForm As Form = Nothing, _
    Optional ByVal Title As String = "", _
    Optional ByVal RootDir As ROOTDIR_ID = ROOTDIR_ALL, _
    Optional ByVal CustomRootDir As String = "", _
    Optional ByVal StartDir As String = "", _
    Optional ByVal NewStyle As Boolean = True, _
    Optional ByVal IncludeFiles As Boolean = False, _
    Optional ByVal OkButtonText As String = "" _
) As String

    Dim lpIDList    As Long
    Dim sBuffer     As String
    Dim tBrowseInfo As BrowseInfo
    Dim clRoot      As Boolean

    If Len(OkButtonText) > 0 Then
        OK_BUTTON_TEXT = OkButtonText
    Else
        OK_BUTTON_TEXT = vbNullString
    End If

    clRoot = False

    If RootDir = ROOTDIR_CUSTOM Then

        If Len(CustomRootDir) > 0 Then

            If (PathIsDirectory(CustomRootDir) And (Left$(CustomRootDir, 2) <> "\\")) Or (Left$(CustomRootDir, 2) = "\\") Then
                tBrowseInfo.pidlRoot = GetPIDLFromPath(CustomRootDir)
                'SHILCreateFromPath StrPtr(CustomRootDir
                '     ), tBrowseInfo.pidlRoot, ByVal 0&
                clRoot = True
            Else
                tBrowseInfo.pidlRoot = GetSpecialFolderID(ROOTDIR_MY_COMPUTER)
            End If

        Else
            tBrowseInfo.pidlRoot = GetSpecialFolderID(ROOTDIR_ALL)
        End If

    Else
        tBrowseInfo.pidlRoot = GetSpecialFolderID(RootDir)
    End If


    If (Len(StartDir) > 0) Then
        m_CurrentDirectory = StartDir & vbNullChar
    Else
        m_CurrentDirectory = vbNullChar
    End If


    If Len(Title) > 0 Then
        tBrowseInfo.lpszTitle = Title
    Else
        tBrowseInfo.lpszTitle = "Select A Directory"
    End If

    tBrowseInfo.lpfnCallback = GetAddressOfFunction(AddressOf BrowseCallbackProc)
    tBrowseInfo.ulFlags = BIF_RETURNONLYFSDIRS

    If IncludeFiles Then
        tBrowseInfo.ulFlags = tBrowseInfo.ulFlags + BIF_BROWSEINCLUDEFILES
    End If

    If NewStyle And isME2KXP Then
        tBrowseInfo.ulFlags = tBrowseInfo.ulFlags + BIF_NEWDIALOGSTYLE + BIF_UAHINT
        OleInitialize Null ' Initialize OLE and COM
    Else
        tBrowseInfo.ulFlags = tBrowseInfo.ulFlags + BIF_STATUSTEXT
    End If

    If Not (OwnerForm Is Nothing) Then tBrowseInfo.hwndOwner = OwnerForm.hwnd
    lpIDList = SHBrowseForFolder(tBrowseInfo)
    If clRoot = True Then CoTaskMemFree tBrowseInfo.pidlRoot

    If (lpIDList) Then
        sBuffer = Space$(MAX_PATH)
        SHGetPathFromIDList lpIDList, sBuffer
        CoTaskMemFree lpIDList
        sBuffer = Left$(sBuffer, InStr(sBuffer, vbNullChar) - 1)
        If Not Right$(sBuffer, 1) = "\" Then
            BrowseForFolder = sBuffer & "\"
        Else
            BrowseForFolder = sBuffer
        End If
    Else
        BrowseForFolder = ""
    End If
End Function
