Attribute VB_Name = "Init"
Option Explicit

Public Const DS_SAMPLERATE      As Long = 44100
Public Const DS_CHANNELS        As Long = 2
Public Const DS_BITSPERSAMPLE   As Long = 16

Private m_clsSession            As Session
Private m_clsPlugins            As PluginManager
Private m_clsFactory            As StreamFactory
Private m_clsMagnWnd            As MagneticWnd
Private m_clsDSP                As DSPManager
Private m_clsTools              As ToolManager
Private m_clsEvents()           As IEventCallback
Private m_lngEventCount         As Long

Public Sub SendEvent(ByVal ev As MONOTON_EVENTS)
    Dim i As Long
    
    For i = 0 To m_lngEventCount - 1
        If Not m_clsEvents(i) Is Nothing Then
            m_clsEvents(i).EventFired ev
        End If
    Next
End Sub

Public Sub RemoveEventCallback(cls As IEventCallback)
    Dim i As Long
    
    For i = 0 To m_lngEventCount - 1
        If m_clsEvents(i) Is cls Then
            ' dirty. Andere Items sollten vorgezogen werden
            Set m_clsEvents(i) = Nothing
        End If
    Next
End Sub

Public Sub AddEventCallback(cls As IEventCallback)
    Dim i As Long
    
    For i = 0 To m_lngEventCount - 1
        If m_clsEvents(i) Is cls Then Exit Sub
    Next
    
    ReDim Preserve m_clsEvents(m_lngEventCount) As IEventCallback
    Set m_clsEvents(m_lngEventCount) = cls
    m_lngEventCount = m_lngEventCount + 1
End Sub

Public Property Get Session() As Session
    Set Session = m_clsSession
End Property

Public Property Get DSP() As DSPManager
    Set DSP = m_clsDSP
End Property

Public Property Get Tools() As ToolManager
    Set Tools = m_clsTools
End Property

Public Property Get MagneticWnd() As MagneticWnd
    Set MagneticWnd = m_clsMagnWnd
End Property

Public Property Get Plugins() As PluginManager
    Set Plugins = m_clsPlugins
End Property

Public Property Get Factory() As StreamFactory
    Set Factory = m_clsFactory
End Property

Sub Main()
    Dim i As Long
    
    Set m_clsPlugins = New PluginManager
    Set m_clsFactory = New StreamFactory
    Set m_clsMagnWnd = New MagneticWnd
    Set m_clsDSP = New DSPManager
    Set m_clsTools = New ToolManager
    Set m_clsSession = New PluginSession
    
    For i = 0 To Plugins.Count - 2
        If Not Plugins.Plugin(i) Is Nothing Then
            Select Case Plugins.Plugin(i).PluginType
                Case PLUGIN_STREAM: m_clsFactory.AddStream Plugins.Plugin(i)
                Case PLUGIN_TOOL:   Tools.Add Plugins.Plugin(i)
                Case PLUGIN_DSP And TypeOf Plugins.Plugin(i) Is MonoPluginLib.IPluginDSP:     m_clsDSP.Add Plugins.Plugin(i)
            End Select
        End If
    Next

    If DirectXInit.InitializeDirectX() Then
        If DirectXInit.InitDirectSound(DS_SAMPLERATE, _
                                       DS_CHANNELS, _
                                       DS_BITSPERSAMPLE, _
                                       DirectXInit.DS_DeviceGUID(1)) Then

            m_clsMagnWnd.AddWindow MonoMain.hWnd
            MonoMain.Show
        Else
            MsgBox "Konnte DirectSound 8 Primary Buffer nicht erstellen!", vbExclamation
        End If
    Else
        MsgBox "Konnte DirectX 8 nicht initialisieren!", vbExclamation
    End If
End Sub
