VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ASMBler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' 32 Bit X86 Assembler
'
' Arne Elster 2007 / 2008


' TODO:
'       * Fr Instructions wie 2-IMUL ModRM Untersttzung
'       * Alles Expressions bei Argumenten
'       * Unsigned Values (im Moment nur ber Hex)


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDst As Any, pSrc As Any, ByVal cBytes As Long _
)


Private Const IMAGE_NUMBEROF_DIRECTORY_ENTRIES  As Long = 16&
Private Const IMAGE_SIZEOF_SHORT_NAME           As Long = 8&
Private Const IMAGE_NT_OPTIONAL_HDR32_MAGIC     As Long = &H10B&
Private Const IMAGE_DOS_HDR16_MAGIC             As Long = &H5A4D&
Private Const IMAGE_DOS_HDR32_MAGIC             As Long = &H4550&
Private Const IMAGE_FILE_MACHINE_I386           As Long = &H14C&

Private Const DOS_CODE_RELOCATIONS As String = _
        "0E1FBA0E00B409CD21B8014CCD21546869732070726" & _
        "F6772616D2063616E6E6F742062652072756E20696E" & _
        "20444F53206D6F64652E0D0D0A2400000000000000"

Private Const MEM_SECTION_SIZE  As Long = 4096
Private Const FILE_SECTION_SIZE As Long = 512

Private Const CHAR_SPACE        As Long = 32
Private Const CHAR_LINEFEED     As Long = 10
Private Const CHAR_CARRIAGE     As Long = 13

Private Const CHAR_QUOTE        As Long = 34
Private Const CHAR_STOP         As Long = 46
Private Const CHAR_SEMICOLON    As Long = 59
Private Const CHAR_COLON        As Long = 58
Private Const CHAR_PLUS         As Long = 43
Private Const CHAR_MINUS        As Long = 45
Private Const CHAR_ASTERISK     As Long = 42
Private Const CHAR_AMPERSAND    As Long = 38
Private Const CHAR_SEPARATOR    As Long = 44
Private Const CHAR_UNDERSCORE   As Long = 95
Private Const CHAR_VERT_BAR     As Long = 124
Private Const CHAR_SHARP        As Long = 35

Private Const CHAR_BRACKET_L    As Long = 91
Private Const CHAR_BRACKET_R    As Long = 93
Private Const CHAR_PARENTH_L    As Long = 40
Private Const CHAR_PARENTH_R    As Long = 41

Private Const CHAR_NUMBER_0     As Long = 48
Private Const CHAR_NUMBER_9     As Long = 57

Private Const CHAR_ALPHA_UA     As Long = 65
Private Const CHAR_ALPHA_UZ     As Long = 90
Private Const CHAR_ALPHA_LA     As Long = 97
Private Const CHAR_ALPHA_LZ     As Long = 122

Private Const REG_COUNT         As Long = 24
Private Const MAX_PARAMETERS    As Long = 3
Private Const MAX_OPCODE_LEN    As Long = 4

Public Enum PESubsystem
    Subsystem_GUI = 2
    Subsystem_CUI = 3
End Enum

Private Enum SectionCharacteristics
    IMAGE_SCN_TYPE_NO_PAD = &H8&
    IMAGE_SCN_CNT_CODE = &H20&
    IMAGE_SCN_CNT_INITIALIZED_DATA = &H40&
    IMAGE_SCN_CNT_UNINITIALIZED_DATA = &H80&
    IMAGE_SCN_LNK_OTHER = &H100&
    IMAGE_SCN_LNK_INFO = &H200&
    IMAGE_SCN_LNK_REMOVE = &H800&
    IMAGE_SCN_LNK_COMDAT = &H1000&
    IMAGE_SCN_NO_DEFER_SPEC_EXC = &H4000&
    IMAGE_SCN_GPREL = &H8000&
    IMAGE_SCN_MEM_PURGEABLE = &H20000
    IMAGE_SCN_MEM_LOCKED = &H40000
    IMAGE_SCN_MEM_PRELOAD = &H80000
    IMAGE_SCN_LNK_NRELOC_OVFL = &H1000000
    IMAGE_SCN_MEM_DISCARDABLE = &H2000000
    IMAGE_SCN_MEM_NOT_CACHED = &H4000000
    IMAGE_SCN_MEM_NOT_PAGED = &H8000000
    IMAGE_SCN_MEM_SHARED = &H10000000
    IMAGE_SCN_MEM_EXECUTE = &H20000000
    IMAGE_SCN_MEM_READ = &H40000000
    IMAGE_SCN_MEM_WRITE = &H80000000
End Enum

Private Enum IMAGE_FILE_CHARACTERISTICS
    IMAGE_FILE_RELOCS_STRIPPED = &H1&
    IMAGE_FILE_EXECUTABLE_IMAGE = &H2&
    IMAGE_FILE_LINE_NUMS_STRIPPED = &H4&
    IMAGE_FILE_LOCAL_SYMS_STRIPPED = &H8&
    IMAGE_FILE_AGGRESSIVE_WS_TRIM = &H10&
    IMAGE_FILE_LARGE_ADDRESS_AWARE = &H20&
    IMAGE_FILE_16BIT_MACHINE = &H40&
    IMAGE_FILE_BYTES_REVERSED_LO = &H80&
    IMAGE_FILE_32BIT_MACHINE = &H100&
    IMAGE_FILE_DEBUG_STRIPPED = &H200&
    IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP = &H400&
    IMAGE_FILE_NET_RUN_FROM_SWAP = &H800&
    IMAGE_FILE_SYSTEM = &H1000&
    IMAGE_FILE_DLL = &H2000&
    IMAGE_FILE_UP_SYSTEM_ONLY = &H4000&
    IMAGE_FILE_BYTES_REVERSED_HI = &H8000&
End Enum

Private Enum OptHeaderTbls
    ETableExport = 0
    ETableImport
    ETableResource
    ETableException
    ETableCertificate
    ETableRelocation
    ETableDebug
    ETableArchitecture
    ETableGlobalPtr
    ETableThreadStorage
    ETableLoadConfig
    ETableBoundImport
    ETableIAT
    ETableDelayImportDescriptor
    ETableCOMPlusRuntime
    ETableReserved
End Enum

Private Type ModRM
    Mod                         As Long
    rm                          As Long
    reg                         As Long
    Disp                        As Long
    DispSize                    As ParamSize
End Type

Private Type SIB
    sscale                      As Long
    index                       As Long
    base                        As Long
End Type

Private Type ASMLabel
    Name                        As String
    Instruction                 As Long
    Offset                      As Long
End Type

Private Type ASMExtern
    LibName                     As String
    Functions()                 As String
    FunctionCount               As Long
End Type

Private Type Pointer
    Registers(REG_COUNT - 1)    As Long
    UsedRegisters               As Long
    Displacement                As Long
    DispSize                    As ParamSize
End Type

Private Type PointerInfo
    TokenIndex                  As Long
    RegisterCount               As Long
    RegisterMultiples           As Boolean
    HasDisplacement             As Boolean          ' Zahl oder Label
    DispSize                    As ParamSize
    ptr                         As Pointer
End Type

Private Type RawData
    size                        As ParamSize
    Values()                    As Long
    ValueCount                  As Long
End Type

Private Type ASMArgument
    TType                       As ParamType
    size                        As ParamSize
    Pointer                     As PointerInfo
    Register                    As ASMRegisters
    FPURegister                 As ASMFPURegisters
    MMRegister                  As ASMXMMRegisters
    SymbolIndex                 As Long
    Value                       As Long
End Type

Private Type ASMInstruction
    Mnemonic                    As String
    Segment                     As ASMSegmentRegs
    args(MAX_PARAMETERS - 1)    As ASMArgument
    OpCodeIndex                 As Long
    argcount                    As Long
    size                        As Long
    Offset                      As Long
    flags                       As OpCodePrefixes
    Data                        As RawData
    Line                        As Long
    Section                     As String
End Type

Private Type Scanner
    Source()                    As Byte
    Length                      As Long
    Position                    As Long
    Line                        As Long
    LinePos                     As Long
    Section                     As String
    NextIsEOI                   As Boolean
    LastWasEOI                  As Boolean
    NextToken                   As ASMToken
    CurToken                    As ASMToken
End Type

Private Type IMAGE_IMPORT_DIRECTORY
    ImportLookupTable           As Long
    TimeDateStamp               As Long
    ForwardChain                As Long
    ModuleName                  As Long
    ImportAddressTable          As Long
End Type

Private Type IMAGE_DATA_DIRECTORY
    VirtualAddress              As Long
    size                        As Long
End Type

Private Type IMAGE_SECTION_HEADER
    SectionName(IMAGE_SIZEOF_SHORT_NAME - 1) As Byte
    VirtSizePhysAddr            As Long
    VirtualAddress              As Long
    SizeOfRawData               As Long
    PointerToRawData            As Long
    PointerToRelocations        As Long
    PointerToLinenumbers        As Long
    NumberOfRelocations         As Integer
    NumberOfLinenumbers         As Integer
    Characteristics             As Long
End Type

Private Type IMAGE_OPTIONAL_HEADER
    Magic                       As Integer
    MajorLinkerVersion          As Byte
    MinorLinkerVersion          As Byte
    SizeOfCode                  As Long
    SizeOfInitializedData       As Long
    SizeOfUninitializedData     As Long
    AddressOfEntryPoint         As Long
    BaseOfCode                  As Long
    BaseOfData                  As Long
    ImageBase                   As Long
    SectionAlignment            As Long
    FileAlignment               As Long
    MajorOperatingSystemVersion As Integer
    MinorOperatingSystemVersion As Integer
    MajorImageVersion           As Integer
    MinorImageVersion           As Integer
    MajorSubsystemVersion       As Integer
    MinorSubsystemVersion       As Integer
    Win32VersionValue           As Long
    SizeOfImage                 As Long
    SizeOfHeaders               As Long
    CheckSum                    As Long
    Subsystem                   As Integer
    DllCharacteristics          As Integer
    SizeOfStackReserve          As Long
    SizeOfStackCommit           As Long
    SizeOfHeapReserve           As Long
    SizeOfHeapCommit            As Long
    LoaderFlags                 As Long
    NumberOfRvaAndSizes         As Long
    DataDirectory(IMAGE_NUMBEROF_DIRECTORY_ENTRIES - 1)  As IMAGE_DATA_DIRECTORY
End Type

Private Type IMAGE_DOS_HEADER
    Magic                       As Integer
    BytesInLastPage             As Integer
    Pages                       As Integer
    Relocations                 As Integer
    ParagraphsInHeader          As Integer
    MinAlloc                    As Integer
    MaxAlloc                    As Integer
    InitialSS                   As Integer
    InitialSP                   As Integer
    CheckSum                    As Integer
    InitialIP                   As Integer
    InitialCS                   As Integer
    RelocationTableFileAddress  As Integer
    OverlayNumber               As Integer
    Reserved1(3)                As Integer
    OEMIdentifier               As Integer
    OEMInformation              As Integer
    Reserved2(9)                As Integer
    NewHeaderOffset             As Long
End Type

Private Type IMAGE_FILE_HEADER
    Machine                     As Integer
    NumberOfSections            As Integer
    TimeDateStamp               As Long
    PointerToSymbolTable        As Long
    NumberOfSymbols             As Long
    SizeOfOptionalHeader        As Integer
    Characteristics             As Integer
End Type

Private Type IMAGE_NT_HEADERS
    Signature                   As Long
    FileHeader                  As IMAGE_FILE_HEADER
    OptionalHeader              As IMAGE_OPTIONAL_HEADER
End Type

Private m_udtScanner            As Scanner

Private m_clsTokens()           As ASMToken
Private m_lngTokenCount         As Long
Private m_lngCurToken           As Long

Private m_udtLabels()           As ASMLabel
Private m_lngLabelCount         As Long

Private m_udtExtern()           As ASMExtern
Private m_lngExternCount        As Long

Private m_udtInstrs()           As ASMInstruction
Private m_lngInstrCount         As Long

Private m_strLastError          As String
Private m_strLastErrorSection   As String
Private m_lngLastErrLine        As Long

Private m_btOutput()            As Byte
Private m_lngOutSize            As Long
Private m_lngOutPos             As Long

Private m_udeSubsystem          As PESubsystem

Private m_blnWritePE            As Boolean
Private m_lngPECodeSize         As Long

Private m_lngBaseAddress        As Long


Private Sub Class_Initialize()
    InitInstructions
    m_udeSubsystem = Subsystem_CUI
End Sub


Public Property Get Subsystem() As PESubsystem
    Subsystem = m_udeSubsystem
End Property


Public Property Let Subsystem(ByVal lngVal As PESubsystem)
    m_udeSubsystem = lngVal
End Property


Public Property Get PEHeader() As Boolean
    PEHeader = m_blnWritePE
End Property


Public Property Let PEHeader(ByVal blnValue As Boolean)
    m_blnWritePE = blnValue
End Property


Public Property Get BaseAddress() As Long
    BaseAddress = m_lngBaseAddress
End Property


Public Property Let BaseAddress(ByVal lngVal As Long)
    m_lngBaseAddress = lngVal
    If m_lngBaseAddress < 0 Then Err.Raise 6, , "Basis < 0 ungltig"
End Property


Public Property Get LastErrorMessage() As String
    LastErrorMessage = m_strLastError
End Property


Public Property Get LastErrorSection() As String
    LastErrorSection = m_strLastErrorSection
End Property


Public Property Get LastErrorLine() As Long
    LastErrorLine = m_lngLastErrLine
End Property


Public Function GetOutput() As Byte()
    GetOutput = m_btOutput
End Function


Public Property Get OutputSize() As Long
    OutputSize = m_lngOutSize
End Property


Public Property Get LabelAddress(ByVal strName As String, Optional ByVal cmp As VbCompareMethod = vbBinaryCompare) As Long
    Dim i As Long
    
    For i = 0 To m_lngLabelCount - 1
        If StrComp(m_udtLabels(i).Name, strName, cmp) = 0 Then
            LabelAddress = m_udtLabels(i).Offset
            Exit Property
        End If
    Next
    
    Err.Raise &H2000, , strName & " kein Label"
End Property


' Ablauf:
'   1. Input in Tokens aufbrechen
'   2. Labels sammeln fr einfachere Validierung
'   3. Instruktionen parsen, Pointer noch nicht komplett verarbeiten
'   4. Gren der Instruktionen und Offsets der Labels berechnen
'   5. Pointer parsen da jetzt erst Labeloffsets bekannt sind
'   6. Instruktionen schreiben
Public Function Assemble( _
    strASM As String, _
    Optional ByVal OnlySize As Boolean = False _
) As Boolean

    ScannerInit strASM
    
    m_lngTokenCount = 0
    m_lngLabelCount = 0
    m_lngInstrCount = 0
    m_lngCurToken = 0
    m_lngOutSize = 0
    m_lngOutPos = 0
    m_lngExternCount = 0
    
    m_strLastError = ""
    m_lngLastErrLine = 0
    
    TokenizeInput
    
    If FindLabels() Then
        If ParseInstructions() Then
            If GetInstructionSizes() Then
                If OnlySize Then
                    Assemble = True
                Else
                    If ParsePointers() Then
                        If m_blnWritePE Then
                            If Not WritePEHeader() Then Exit Function
                        End If
                        
                        If AssembleInstructions() Then
                            If m_blnWritePE Then
                                OutputJumpTo RoundToMinSize(OutputPosition)
                                WritePEImports
                            End If
                            Assemble = True
                        End If
                    End If
                End If
            End If
        End If
    End If
End Function


Private Sub WritePEImports()
    Dim lngRVAIAT   As Long
    Dim ntHdr       As IMAGE_NT_HEADERS
    Dim scHdr       As IMAGE_SECTION_HEADER
    
    Const SECTIONS = 2
    
    lngRVAIAT = RoundToSectionSize(Len(ntHdr) + Len(scHdr) * SECTIONS)
    lngRVAIAT = lngRVAIAT + RoundToSectionSize(m_lngPECodeSize)
    
    WriteIAT lngRVAIAT
    WriteIIDs lngRVAIAT
    WriteIAT lngRVAIAT
    WriteImpNames
End Sub


Private Sub WriteImpNames()
    Dim i       As Long
    Dim j       As Long
    
    For i = 0 To m_lngExternCount - 1
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            OutputInteger 0
            WriteStr0Ev m_udtExtern(i).Functions(j)
        Next
        WriteStr0Ev m_udtExtern(i).LibName
    Next
End Sub


Private Sub WriteStr0Ev(ByVal strN As String)
    Dim btN()   As Byte
    
    btN = StrConv(strN & ChrW$(0), vbFromUnicode)
    OutputMem VarPtr(btN(0)), UBound(btN) + 1
    
    If (UBound(btN) + 1) Mod 2 = 1 Then
        OutputByte 0
    End If
End Sub


Private Sub WriteIIDs(ByVal base As Long)
    Dim i       As Long
    Dim j       As Long
    Dim im      As IMAGE_IMPORT_DIRECTORY
    Dim eim     As IMAGE_IMPORT_DIRECTORY
    
    For i = 0 To m_lngExternCount - 1
        With im
            .ModuleName = base + GetRelOfLibname(i)
            .ImportAddressTable = base + GetIATLibStart(i)
            .ImportLookupTable = base + GetILTLibStart(i)
        End With
        
        OutputMem VarPtr(im), Len(im)
    Next
    
    OutputMem VarPtr(eim), Len(eim)
End Sub


Private Sub WriteIAT(ByVal base As Long)
    Dim i   As Long
    Dim j   As Long
    
    For i = 0 To m_lngExternCount - 1
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            OutputLong base + GetRelOfFncname(i, j)
        Next
        OutputLong 0
    Next
End Sub


Private Function GetRelOfFncname(ByVal libdx As Long, ByVal fncidx As Long) As Long
    Dim i   As Long
    Dim j   As Long
    Dim sz  As Long
    Dim im  As IMAGE_IMPORT_DIRECTORY
    
    For i = 0 To m_lngExternCount - 1
        sz = sz + 4 * (m_udtExtern(i).FunctionCount + 1) * 2
        sz = sz + Len(im)
    Next
    If m_lngExternCount > 0 Then sz = sz + Len(im)
    
    For i = 0 To m_lngExternCount - 1
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            If (i = libdx) And (j = fncidx) Then
                GetRelOfFncname = sz
                Exit Function
            Else
                sz = sz + 2 + EvenSize(Len(m_udtExtern(i).Functions(j)) + 1)
            End If
        Next
        sz = sz + EvenSize(Len(m_udtExtern(i).LibName) + 1)
    Next
End Function


Private Function GetRelOfLibname(ByVal index As Long) As Long
    Dim i   As Long
    Dim j   As Long
    Dim sz  As Long
    Dim im  As IMAGE_IMPORT_DIRECTORY
    
    For i = 0 To m_lngExternCount - 1
        sz = sz + 4 * (m_udtExtern(i).FunctionCount + 1) * 2
        sz = sz + Len(im)
    Next
    If m_lngExternCount > 0 Then sz = sz + Len(im)
    
    For i = 0 To m_lngExternCount - 1
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            sz = sz + 2 + EvenSize(Len(m_udtExtern(i).Functions(j)) + 1)
        Next
        
        If i <> index Then
            sz = sz + EvenSize(Len(m_udtExtern(i).LibName) + 1)
        Else
            Exit For
        End If
    Next
    
    GetRelOfLibname = sz
End Function


Private Function WritePEHeader() As Boolean
    Dim mzHdr   As IMAGE_DOS_HEADER
    Dim ntHdr   As IMAGE_NT_HEADERS
    Dim scHdr   As IMAGE_SECTION_HEADER
    Dim sdHdr   As IMAGE_SECTION_HEADER
    Dim impTbl  As IMAGE_IMPORT_DIRECTORY
    Dim lngImp  As Long
    Dim btDOS() As Byte
    
    Const SECTIONS = 2
    
    If GetLabelIndex("MAIN") = -1 Then
        SetError "Einsprungspunkt ""Main"" nicht gefunden.", 0, ""
        Exit Function
    End If
    
    lngImp = GetNeededImportsSize()
    If lngImp = 0 Then lngImp = 1
    
    With mzHdr
        .Magic = IMAGE_DOS_HDR16_MAGIC
        .BytesInLastPage = 144
        .Pages = 3
        .ParagraphsInHeader = 4
        .MaxAlloc = &HFFFF
        .InitialSP = &HB8
        .RelocationTableFileAddress = &H40
        .NewHeaderOffset = Len(mzHdr) + 64
    End With
      
    With ntHdr
        .Signature = IMAGE_DOS_HDR32_MAGIC
        
        With .FileHeader
            .Machine = IMAGE_FILE_MACHINE_I386
            .NumberOfSections = SECTIONS
            .SizeOfOptionalHeader = Len(ntHdr.OptionalHeader)
            .Characteristics = IMAGE_FILE_RELOCS_STRIPPED Or IMAGE_FILE_LINE_NUMS_STRIPPED Or _
                               IMAGE_FILE_LOCAL_SYMS_STRIPPED Or IMAGE_FILE_EXECUTABLE_IMAGE Or _
                               IMAGE_FILE_32BIT_MACHINE Or IMAGE_FILE_DEBUG_STRIPPED Or _
                               IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP Or IMAGE_FILE_NET_RUN_FROM_SWAP
        End With
        
        With .OptionalHeader
            .Magic = IMAGE_NT_OPTIONAL_HDR32_MAGIC
            .SizeOfCode = RoundToMinSize(m_lngPECodeSize)
            .SizeOfInitializedData = RoundToMinSize(lngImp)
            .BaseOfCode = RoundToSectionSize(Len(ntHdr) + Len(scHdr) * SECTIONS)
            .BaseOfData = .BaseOfCode + RoundToSectionSize(.SizeOfCode)
            .AddressOfEntryPoint = m_udtLabels(GetLabelIndex("MAIN")).Offset - m_lngBaseAddress
            .ImageBase = m_lngBaseAddress
            .SectionAlignment = MEM_SECTION_SIZE
            .FileAlignment = FILE_SECTION_SIZE
            .MajorOperatingSystemVersion = 4
            .MajorSubsystemVersion = 4
            .SizeOfImage = .BaseOfData + RoundToSectionSize(lngImp)
            .SizeOfHeaders = GetPEHeaderSize()
            .Subsystem = m_udeSubsystem
            .SizeOfStackReserve = &H100000
            .SizeOfStackCommit = &H1000
            .SizeOfHeapReserve = &H100000
            .SizeOfHeapCommit = &H1000
            .NumberOfRvaAndSizes = 16
            
            With .DataDirectory(ETableImport)
                .VirtualAddress = ntHdr.OptionalHeader.BaseOfCode + _
                                  RoundToSectionSize(ntHdr.OptionalHeader.SizeOfCode) + _
                                  GetNeededIATSize()
                                  
                .size = Len(impTbl)
            End With
            
            With .DataDirectory(ETableIAT)
                .VirtualAddress = ntHdr.OptionalHeader.BaseOfCode + _
                                  RoundToSectionSize(ntHdr.OptionalHeader.SizeOfCode)
                                  
                .size = GetNeededIATSize()
            End With
        End With
    End With
    
    With scHdr
        WriteSectionName scHdr, ".text"
        .VirtSizePhysAddr = m_lngPECodeSize
        .VirtualAddress = ntHdr.OptionalHeader.BaseOfCode
        .SizeOfRawData = RoundToMinSize(m_lngPECodeSize)
        .PointerToRawData = GetPEHeaderSize()
        .Characteristics = IMAGE_SCN_CNT_CODE Or _
                           IMAGE_SCN_MEM_EXECUTE Or _
                           IMAGE_SCN_MEM_READ Or _
                           IMAGE_SCN_MEM_WRITE
    End With
    
    With sdHdr
        WriteSectionName sdHdr, ".rdata"
        .VirtSizePhysAddr = lngImp
        .VirtualAddress = ntHdr.OptionalHeader.BaseOfData
        .SizeOfRawData = RoundToMinSize(lngImp)
        .PointerToRawData = scHdr.PointerToRawData + scHdr.SizeOfRawData
        .Characteristics = IMAGE_SCN_MEM_READ Or _
                           IMAGE_SCN_MEM_WRITE
    End With
    
    btDOS = HexToByte(DOS_CODE_RELOCATIONS)
    
    OutputMem VarPtr(mzHdr), Len(mzHdr)
    OutputMem VarPtr(btDOS(0)), UBound(btDOS) + 1
    OutputMem VarPtr(ntHdr), Len(ntHdr)
    OutputMem VarPtr(scHdr), Len(scHdr)
    OutputMem VarPtr(sdHdr), Len(sdHdr)
    
    OutputJumpTo RoundToMinSize(OutputPosition)
    
    WritePEHeader = True
End Function


Private Sub WriteSectionName(sc As IMAGE_SECTION_HEADER, ByVal strName As String)
    Dim i   As Long
    
    For i = 1 To Len(strName)
        sc.SectionName(i - 1) = Asc(Mid$(strName, i, 1))
    Next
End Sub


Private Function GetPEHeaderSize() As Long
    Dim mzHdr   As IMAGE_DOS_HEADER
    Dim ntHdr   As IMAGE_NT_HEADERS
    Dim scHdr   As IMAGE_SECTION_HEADER
    
    Const SECTIONS = 2
    
    GetPEHeaderSize = RoundToMinSize(Len(mzHdr) + 64 + Len(ntHdr) + Len(scHdr) * SECTIONS)
End Function


' Jede Instruktion hat Prfixe (opt.), einen OpCode und Argumente (opt.).
' Diese nacheinander ausgeben
Private Function AssembleInstructions() As Boolean
    Dim i       As Long
    Dim lngSz   As Long
    
    For i = 0 To m_lngInstrCount - 1
        lngSz = m_lngOutPos
        
        If m_udtInstrs(i).Data.size <> BitsUnknown Then
            If Not RawDataOut(m_udtInstrs(i).Data) Then Exit Function
        Else
            InstructionOutPrefixes m_udtInstrs(i)
            InstructionOutOpCode m_udtInstrs(i)
            If Not InstructionOutArgs(m_udtInstrs(i)) Then Exit Function
        End If
        
        lngSz = m_lngOutPos - lngSz
        If lngSz <> m_udtInstrs(i).size Then Err.Raise 123, , "Falsche Gre bei Ausgabe"
    Next
    
    AssembleInstructions = True
End Function


' db, dw, dd Ketten ausgeben
Private Function RawDataOut(Data As RawData) As Boolean
    Dim i   As Long
    
    For i = 0 To Data.ValueCount - 1
        OutputBytes Data.Values(i), Data.size
    Next
    
    RawDataOut = True
End Function


' Argumente ausgeben. ModR/M Byte, falls bentigt.
' Auerdem SIB Byte, wenn im Pointer 2 Register,
' Registervielfache und/oder ESP verwendet wurden.
Private Function InstructionOutArgs(udtInstr As ASMInstruction) As Boolean
    Dim i               As Long
    Dim j               As Long
    
    Dim udtModRM        As ModRM
    Dim blnModRM        As Boolean
    Dim blnSIBNeeded    As Boolean
    
    Dim lngImmVal()     As Long
    Dim udeImmSize()    As ParamSize
    Dim lngImmValCnt    As Long
    Dim blnImmVal       As Boolean
    
    Dim lngDisplacement As Long
    Dim udeDispSize     As ParamSize
    Dim blnDisplacement As Boolean
    
    Dim lngSIBPtrIdx    As Long
    
    Dim blnGotXMMReg    As Boolean
    Dim lngMMVal        As Long
    
    With Instructions(udtInstr.OpCodeIndex)
        blnModRM = .ModRM
        If .RegOpExt > -1 Then
            udtModRM.reg = .RegOpExt
            blnGotXMMReg = True
        End If
    End With
    
    For i = 0 To udtInstr.argcount - 1
        With Instructions(udtInstr.OpCodeIndex).Parameters(i)
            If Not .Forced Then
            
                If (.PType = ParamImm) Or (.PType = ParamRel) Then
                    ' Eine Instruktion kann mehrere Immediates haben
                    ReDim Preserve lngImmVal(lngImmValCnt) As Long
                    ReDim Preserve udeImmSize(lngImmValCnt) As ParamSize
                    
                    If udtInstr.args(i).TType = ParamImm Then
                        lngImmVal(lngImmValCnt) = udtInstr.args(i).Value
                    ElseIf udtInstr.args(i).TType = ParamRel Then
                        lngImmVal(lngImmValCnt) = m_udtLabels(udtInstr.args(i).SymbolIndex).Offset
                    End If
                    
                    If .PType = ParamRel Then
                        ' Ist ein relativer Wert gefragt, aus absoluter Adresse
                        ' eine zum Instruktionsende relative Adresse basteln
                        lngImmVal(lngImmValCnt) = lngImmVal(lngImmValCnt) - (udtInstr.Offset + udtInstr.size)
                    End If
                    
                    If (SizesForInt(lngImmVal(lngImmValCnt)) And .size) = 0 Then
                        SetError "Relativer Wert zu gro fr Instruktion", udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                    
                    udeImmSize(lngImmValCnt) = .size
                    lngImmValCnt = lngImmValCnt + 1
                    blnImmVal = True
                    
                ElseIf .PType = ParamReg Then
                    ' Register muss in ModR/M Byte stehen, sonst wrs forced
                    udtModRM.reg = ModRMRegNum(udtInstr.args(i).Register)
                
                ElseIf .PType = ParamMM Then
                    Select Case udtInstr.args(i).MMRegister
                        Case MM0, XMM0: lngMMVal = 0
                        Case MM1, XMM1: lngMMVal = 1
                        Case MM2, XMM2: lngMMVal = 2
                        Case MM3, XMM3: lngMMVal = 3
                        Case MM4, XMM4: lngMMVal = 4
                        Case MM5, XMM5: lngMMVal = 5
                        Case MM6, XMM6: lngMMVal = 6
                        Case MM7, XMM7: lngMMVal = 7
                    End Select
                    
                    If blnGotXMMReg Then
                        udtModRM.Mod = 3
                        udtModRM.rm = lngMMVal
                    Else
                        udtModRM.reg = lngMMVal
                        blnGotXMMReg = True
                    End If
                
                ElseIf (.PType = (ParamMem Or ParamReg)) Or _
                       (.PType = (ParamMem Or ParamMM)) Or _
                       (.PType = ParamMem) Then
                       
                    If (.PType = ParamMem) And (Not blnModRM) Then
                        ' !#! Kann das auch mehrmals pro Instruktion vorkommen? !#!
                        lngDisplacement = udtInstr.args(i).Pointer.ptr.Displacement
                        udeDispSize = Bits32
                        blnDisplacement = True
                    Else
                        If udtInstr.args(i).TType = ParamMem Then
                            Select Case udtInstr.args(i).Pointer.RegisterCount
                                Case 0:
                                    ' kein Register im Pointer, nur Displacement mglich
                                    If udtInstr.args(i).Pointer.HasDisplacement Then
                                        udtModRM.Disp = udtInstr.args(i).Pointer.ptr.Displacement
                                        udtModRM.DispSize = Bits32
                                        udtModRM.Mod = 0
                                        udtModRM.rm = 5
                                    End If
                                    
                                Case 1:
                                    ' 1 Register im Pointer, kann noch mit ModR/M
                                    ' kodiert werden, auer Register ist ESP
                                    ' oder ist ein Vielfaches (reg*2/3/4/5/8/9)
                                    If udtInstr.args(i).Pointer.HasDisplacement Then
                                        udtModRM.Disp = udtInstr.args(i).Pointer.ptr.Displacement
                                        udtModRM.DispSize = udtInstr.args(i).Pointer.ptr.DispSize
                                        Select Case udtModRM.DispSize
                                            Case Bits8:     udtModRM.Mod = 1
                                            Case Else:      udtModRM.Mod = 2
                                        End Select
                                    Else
                                        udtModRM.Mod = 0
                                    End If
                                    
                                    For j = 0 To REG_COUNT - 1
                                        If udtInstr.args(i).Pointer.ptr.Registers(j) Then
                                            If udtInstr.args(i).Pointer.ptr.Registers(j) > 1 Then
                                                blnSIBNeeded = True
                                                lngSIBPtrIdx = i
                                            Else
                                                Select Case IdxToReg(j)
                                                    Case RegEAX: udtModRM.rm = 0
                                                    Case RegECX: udtModRM.rm = 1
                                                    Case RegEDX: udtModRM.rm = 2
                                                    Case RegEBX: udtModRM.rm = 3
                                                    Case RegEBP: udtModRM.rm = 5
                                                    Case RegESI: udtModRM.rm = 6
                                                    Case RegEDI: udtModRM.rm = 7
                                                    Case RegESP: blnSIBNeeded = True
                                                                 lngSIBPtrIdx = i
                                                End Select
                                            End If
                                            
                                            Exit For
                                        End If
                                    Next
                                    
                                Case 2:
                                    ' 2 Register, SIB ntig
                                    If udtInstr.args(i).Pointer.HasDisplacement Then
                                        udtModRM.Disp = udtInstr.args(i).Pointer.ptr.Displacement
                                        udtModRM.DispSize = udtInstr.args(i).Pointer.ptr.DispSize
                                        Select Case udtModRM.DispSize
                                            Case Bits8:     udtModRM.Mod = 1
                                            Case Else:      udtModRM.Mod = 2
                                        End Select
                                    Else
                                        udtModRM.Mod = 0
                                    End If
                                    
                                    blnSIBNeeded = True
                                    lngSIBPtrIdx = i
                                    
                                Case Else:
                                    SetError "Ungltige Anzahl an Registern in Ptr", udtInstr.Line, udtInstr.Section
                                    Exit Function
                                    
                            End Select
                            
                        ElseIf udtInstr.args(i).TType = ParamReg Then
                            ' 2. Register in ModR/M kodieren
                            udtModRM.Mod = 3
                            udtModRM.rm = ModRMRegNum(udtInstr.args(i).Register)
                        
                        ElseIf udtInstr.args(i).TType = (ParamMem Or ParamExt) Then
                            lngDisplacement = udtInstr.args(i).Pointer.ptr.Displacement
                            udeDispSize = Bits32
                            udtModRM.rm = 5
                            blnDisplacement = True
                        
                        ElseIf udtInstr.args(i).TType = ParamMM Then
                            Select Case udtInstr.args(i).MMRegister
                                Case MM0, XMM0: udtModRM.rm = 0
                                Case MM1, XMM1: udtModRM.rm = 1
                                Case MM2, XMM2: udtModRM.rm = 2
                                Case MM3, XMM3: udtModRM.rm = 3
                                Case MM4, XMM4: udtModRM.rm = 4
                                Case MM5, XMM5: udtModRM.rm = 5
                                Case MM6, XMM6: udtModRM.rm = 6
                                Case MM7, XMM7: udtModRM.rm = 7
                            End Select
                            udtModRM.Mod = 3
                        
                        End If
                    End If
                    
                End If
                
            End If
        End With
    Next
    
    If blnSIBNeeded Then
        udtModRM.rm = 4
        If Not WriteSIB(udtInstr, udtModRM, udtInstr.args(lngSIBPtrIdx).Pointer.ptr) Then
            Exit Function
        End If
    Else
        If blnModRM Then WriteModRM udtModRM
    End If
    
    If blnDisplacement Then OutputBytes lngDisplacement, udeDispSize
    If blnImmVal Then
        For i = 0 To lngImmValCnt - 1
            OutputBytes lngImmVal(i), udeImmSize(i)
        Next
    End If
    
    If Instructions(udtInstr.OpCodeIndex).Now3DByte > -1 Then
        OutputByte Instructions(udtInstr.OpCodeIndex).Now3DByte
    End If
    
    InstructionOutArgs = True
End Function


Private Function WriteSIB( _
    udtInstr As ASMInstruction, _
    rm As ModRM, _
    ptr As Pointer _
) As Boolean

    Dim udtSIB          As SIB
    Dim udeReg(1)       As ASMRegisters
    Dim lngRegCnt(1)    As Long
    Dim lngScale        As Long
    Dim lngBase         As Long
    Dim i               As Long
    Dim j               As Long
    
    ' das oder die verwendeten Register finden
    For i = 0 To REG_COUNT - 1
        If ptr.Registers(i) Then
            udeReg(j) = IdxToReg(i)
            lngRegCnt(j) = ptr.Registers(i)
            j = j + 1
        End If
    Next
    
    ' Feststellen, welches Register ein Vielfaches betrgt und damit
    ' das Scale Register ist. Das Base Reg ist dann das andere.
    If lngRegCnt(0) >= 1 And lngRegCnt(1) = 1 Then
        lngScale = 0
    ElseIf lngRegCnt(1) >= 1 And lngRegCnt(0) = 1 Then
        lngScale = 1
    End If
    lngBase = 1 - lngScale
    
    If (ptr.UsedRegisters = 1) And (lngRegCnt(0) = 1) Then
        ' nur ein Register verwendet, das kein vielfaches ist
        udtSIB.sscale = 0
        udtSIB.index = 4
        
        Select Case udeReg(0)
            Case RegEAX:    udtSIB.base = 0
            Case RegECX:    udtSIB.base = 1
            Case RegEDX:    udtSIB.base = 2
            Case RegEBX:    udtSIB.base = 3
            Case RegESP:    udtSIB.base = 4     ' <= alles andere durch ModRM darstellbar
            Case RegEBP:    udtSIB.base = 5
            Case RegESI:    udtSIB.base = 6
            Case RegEDI:    udtSIB.base = 7
        End Select
        
    Else
    
        If (ptr.UsedRegisters = 1) And (lngRegCnt(0) > 1) Then
            ' ein Register, das ein vielfaches ist
            If lngRegCnt(0) = 2 Or _
               lngRegCnt(0) = 3 Or _
               lngRegCnt(0) = 5 Or _
               lngRegCnt(0) = 9 Then
               
                If lngRegCnt(0) = 2 Then
                    udtSIB.sscale = 0
                Else
                    udtSIB.sscale = GetFirstSetBitIdx(lngRegCnt(0) - 1)
                End If
                
                Select Case udeReg(0)
                    Case RegEAX:    udtSIB.index = 0:   udtSIB.base = 0
                    Case RegECX:    udtSIB.index = 1:   udtSIB.base = 1
                    Case RegEDX:    udtSIB.index = 2:   udtSIB.base = 2
                    Case RegEBX:    udtSIB.index = 3:   udtSIB.base = 3
                    Case RegESI:    udtSIB.index = 6:   udtSIB.base = 6
                    Case RegEDI:    udtSIB.index = 7:   udtSIB.base = 7
                    Case RegEBP:    udtSIB.index = 5:   udtSIB.base = 5
                                    rm.Mod = 1
                    Case Else:
                        SetError "In SIB ungltige Vielfache von Register", udtInstr.Line, udtInstr.Section
                        Exit Function
                End Select
                
            ElseIf lngRegCnt(0) = 4 Or lngRegCnt(0) = 8 Then
                ' wre Mod vom ModR/M Byte hier > 0,
                ' wrde EBP+sbyte oder EBP+sdword mitkodiert
                rm.Mod = 0
                udtSIB.base = 5
                udtSIB.sscale = GetFirstSetBitIdx(lngRegCnt(0))
                
                Select Case udeReg(0)
                    Case RegEAX:    udtSIB.index = 0
                    Case RegECX:    udtSIB.index = 1
                    Case RegEDX:    udtSIB.index = 2
                    Case RegEBX:    udtSIB.index = 3
                    Case RegEBP:    udtSIB.index = 5
                    Case RegESI:    udtSIB.index = 6
                    Case RegEDI:    udtSIB.index = 7
                    Case Else:
                        SetError "In SIB ungltige Vielfache von Register", udtInstr.Line, udtInstr.Section
                        Exit Function
                End Select
            
            Else
                SetError "In SIB ungltige Vielfache von Register", udtInstr.Line, udtInstr.Section
                Exit Function
                
            End If
            
        ElseIf ptr.UsedRegisters = 2 Then
            ' 2 Register im Pointer
            
            Select Case lngRegCnt(lngScale)
                Case 1, 2, 4, 8:
                    ' Scale Register darf nur 1/2/4/8-fach gewichtet werden
                Case Else:
                    SetError "Mgliche Vielfache von Scale Register: 1, 2, 4, 8", udtInstr.Line, udtInstr.Section
                    Exit Function
            End Select
            
            If lngRegCnt(lngBase) <> 1 Then
                SetError "Base Register kann kein Vielfaches betragen", udtInstr.Line, udtInstr.Section
                Exit Function
            End If
            
            ' ESP kann nur in der Base kodiert werden,
            ' darf deshalb nicht Scale sein.
            ' Gleiches Spiel mit EBP, nur andersrum.
            If (lngRegCnt(lngScale) = 1) And (lngRegCnt(lngBase)) = 1 Then
                If (udeReg(lngScale) = RegESP) Or (udeReg(lngBase) = RegEBP) Then
                    lngScale = lngBase
                    lngBase = 1 - lngScale
                End If
            End If
            
            udtSIB.sscale = GetFirstSetBitIdx(lngRegCnt(lngScale))
            
            Select Case udeReg(lngScale)
                Case RegEAX:    udtSIB.index = 0
                Case RegECX:    udtSIB.index = 1
                Case RegEDX:    udtSIB.index = 2
                Case RegEBX:    udtSIB.index = 3
                Case RegEBP:    udtSIB.index = 5
                Case RegESI:    udtSIB.index = 6
                Case RegEDI:    udtSIB.index = 7
                Case Else:
                    SetError "Ungltiges Scale Register", udtInstr.Line, udtInstr.Section
                    Exit Function
            End Select
            
            Select Case udeReg(lngBase)
                Case RegEAX:    udtSIB.base = 0
                Case RegECX:    udtSIB.base = 1
                Case RegEDX:    udtSIB.base = 2
                Case RegEBX:    udtSIB.base = 3
                Case RegESP:    udtSIB.base = 4
                Case RegEBP:    udtSIB.base = 5
                Case RegESI:    udtSIB.base = 6
                Case RegEDI:    udtSIB.base = 7
                Case Else:
                    SetError "Ungltiges Base Register", udtInstr.Line, udtInstr.Section
                    Exit Function
            End Select
        End If
    End If
    
    OutputByte (rm.Mod * &H40) Or (rm.reg * &H8) Or rm.rm
    OutputByte (udtSIB.sscale * &H40) Or (udtSIB.index * &H8) Or udtSIB.base
    If rm.DispSize <> BitsUnknown Then OutputBytes rm.Disp, rm.DispSize
    
    WriteSIB = True
End Function


Private Function ModRMRegNum(ByVal reg As ASMRegisters) As Long
    Select Case reg
        Case RegAL, RegAX, RegEAX:  ModRMRegNum = 0
        Case RegCL, RegCX, RegECX:  ModRMRegNum = 1
        Case RegDL, RegDX, RegEDX:  ModRMRegNum = 2
        Case RegBL, RegBX, RegEBX:  ModRMRegNum = 3
        Case RegAH, RegSP, RegESP:  ModRMRegNum = 4
        Case RegCH, RegBP, RegEBP:  ModRMRegNum = 5
        Case RegDH, RegSI, RegESI:  ModRMRegNum = 6
        Case RegBH, RegDI, RegEDI:  ModRMRegNum = 7
    End Select
End Function


Private Sub WriteModRM(rm As ModRM)
    OutputByte (rm.Mod * &H40) Or (rm.reg * &H8) Or rm.rm
    If rm.DispSize <> BitsUnknown Then OutputBytes rm.Disp, rm.DispSize
End Sub


Private Sub InstructionOutOpCode(udtInstr As ASMInstruction)
    Dim i As Long
    
    With Instructions(udtInstr.OpCodeIndex)
        For i = 0 To .OpCodeLen - 1
            OutputByte .OpCode(i)
        Next
    End With
End Sub


Private Sub InstructionOutPrefixes(udtInstr As ASMInstruction)
    With Instructions(udtInstr.OpCodeIndex)
        If (.Prefixes And PrefixFlgOperandSizeOverride) Then _
            OutputByte PREFIX_OPERAND_SIZE_OVERRIDE
        If (.Prefixes And PrefixFlgAddressSizeOverride) Then _
            OutputByte PREFIX_ADDRESS_SIZE_OVERRIDE
        If (.Prefixes And PrefixFlgBranchNotTaken) Then _
            OutputByte PREFIX_BRANCH_NOT_TAKEN
        If (.Prefixes And PrefixFlgBranchTaken) Then _
            OutputByte PREFIX_BRANCH_TAKEN
    End With
    
    With udtInstr
        If (.flags And PrefixFlgLock) Then _
            OutputByte PREFIX_LOCK
        If (.flags And PrefixFlgRep) Then _
            OutputByte PREFIX_REP
        If (.flags And PrefixFlgRepne) Then _
            OutputByte PREFIX_REPNE
    End With
    
    Select Case udtInstr.Segment
        Case SegCS: OutputByte PREFIX_SEGMENT_CS
        Case SegDS: OutputByte PREFIX_SEGMENT_DS
        Case SegES: OutputByte PREFIX_SEGMENT_ES
        Case SegFS: OutputByte PREFIX_SEGMENT_FS
        Case SegGS: OutputByte PREFIX_SEGMENT_GS
        Case SegSS: OutputByte PREFIX_SEGMENT_SS
    End Select
End Sub


Private Sub OutputMem(ByVal ptr As Long, ByVal Bytes As Long)
    If m_lngOutPos + Bytes > m_lngOutSize Then
        Err.Raise 123456, , "Nicht gengend Platz in Ausgabearray"
    End If
    
    CopyMemory m_btOutput(m_lngOutPos), ByVal ptr, Bytes
    m_lngOutPos = m_lngOutPos + Bytes
End Sub


Private Sub OutputJumpTo(ByVal lngVal As Long)
    If lngVal >= m_lngOutSize Then
        Err.Raise 123456, , "Neue Position auerhalb von Ausgabearray"
    End If
    
    m_lngOutPos = lngVal
End Sub


Private Property Get OutputPosition() As Long
    OutputPosition = m_lngOutPos
End Property


Private Sub OutputBytes(ByVal Value As Long, ByVal size As ParamSize)
    Select Case size
        Case Bits8:     OutputByte Value
        Case Bits16:    OutputInteger Value
        Case Bits32:    OutputLong Value
        Case Else:      Err.Raise 123456, , "Ungltige Gre"
    End Select
End Sub


Private Sub OutputByte(ByVal Value As Long)
    If Value < 0 Then
        m_btOutput(m_lngOutPos) = CByte(Value + 256)    ' Signed Byte
    Else
        m_btOutput(m_lngOutPos) = CByte(Value)
    End If
    
    m_lngOutPos = m_lngOutPos + 1
End Sub


' !#! Untersttzt keine Unsigned Ints !#!
Private Sub OutputInteger(ByVal Value As Long)
    CopyMemory m_btOutput(m_lngOutPos), Value, 2
    m_lngOutPos = m_lngOutPos + 2
End Sub


' !#! Untersttzt keine Unsigned Ints !#!
Private Sub OutputLong(ByVal Value As Long)
    CopyMemory m_btOutput(m_lngOutPos), Value, 4
    m_lngOutPos = m_lngOutPos + 4
End Sub


Private Function ParsePointers() As Boolean
    Dim i   As Long
    Dim j   As Long
    
    For i = 0 To m_lngInstrCount - 1
        For j = 0 To m_udtInstrs(i).argcount - 1
            With m_udtInstrs(i).args(j)
                If .TType = ParamMem Then
                    m_lngCurToken = .Pointer.TokenIndex
                    If Not ParsePointer(.Pointer.ptr) Then Exit Function
                End If
            End With
        Next
    Next
    
    ParsePointers = True
End Function


' Muss nichts mehr validiert werden, wurde schon validiert.
Private Function ParsePointer(ptr As Pointer) As Boolean
    Dim lngSgn      As Long
    Dim lngTms      As Long
    Dim lngVal      As Long
    Dim i           As Long
    Dim lngReg      As Long
    Dim blnReg      As Boolean
    
    If Not Match(ASMTokenBracketLeft) Then
        SetError """["" erwartet", Token.Line, Token.Section
        Exit Function
    End If
    
    If Match(ASMTokenOpAdd) Then
        lngSgn = 1
    ElseIf Match(ASMTokenOpSub) Then
        lngSgn = -1
    Else
        lngSgn = 1
    End If
    
    Do
        lngTms = 1
        blnReg = False
        
        Do
            Select Case Token.TType
                Case ASMTokenRegister:
                    blnReg = True
                    lngReg = RegToIdx(RegStrToReg(Token.Content))
                    Match ASMTokenRegister
                Case ASMTokenValue:
                    lngTms = lngTms * Token.Value
                    Match ASMTokenValue
                Case ASMTokenSymbol:
                    lngTms = lngTms * m_udtLabels(GetLabelIndex(Token.Content)).Offset
                    Match ASMTokenSymbol
            End Select
        Loop While Match(ASMTokenOpMul)
        
        If blnReg Then
            ptr.Registers(lngReg) = ptr.Registers(lngReg) + lngSgn * lngTms
        Else
            ptr.Displacement = ptr.Displacement + lngSgn * lngTms
        End If
        
        If Match(ASMTokenOpAdd) Then
            lngSgn = 1
        ElseIf Match(ASMTokenOpSub) Then
            lngSgn = -1
        Else
            Exit Do
        End If
    Loop
    
    If Not Match(ASMTokenBracketRight) Then
        SetError """]"" erwartet", Token.Line, Token.Section
    Else
        ParsePointer = True
    End If
End Function


Private Function GetInstructionSizes() As Boolean
    Dim i           As Long
    Dim j           As Long
    Dim k           As Long
    Dim size        As Long
    Dim lngImpSz    As Long
    Dim blnFoundI   As Boolean

    For i = 0 To m_lngInstrCount - 1                ' alle Instructions im Quelltext
        If m_udtInstrs(i).Data.size <> BitsUnknown Then
            With m_udtInstrs(i)
                .size = .Data.ValueCount * .Data.size \ 8
            End With
        Else
            blnFoundI = False
            
            For j = 0 To InstructionCount - 1       ' alle bekannten Instructions
                If StrComp(m_udtInstrs(i).Mnemonic, Instructions(j).Mnemonic, vbTextCompare) = 0 Then
                    blnFoundI = True
                    
                    If CompareInstrs(m_udtInstrs(i), Instructions(j)) Then
                        ' OpCode Lnge + alle Prfixe, ModR/M Byte
                        size = Instructions(j).OpCodeLen + _
                               BitCount(Instructions(j).Prefixes Or m_udtInstrs(i).flags) + _
                               Abs(m_udtInstrs(i).Segment <> SegUnknown) + _
                               Abs(Instructions(j).ModRM) + _
                               Abs(Instructions(j).Now3DByte > -1)
                        
                        ' Dazu kommen noch Immediates, Displacement, SIB Byte
                        If Instructions(j).ParamCount > 0 Then
                            For k = 0 To Instructions(j).ParamCount - 1
                                With Instructions(j).Parameters(k)
                                    If Not .Forced Then
                                    
                                        Select Case .PType
                                        
                                            Case ParamImm, ParamRel:
                                                size = size + .size \ 8 ' Imm
                                            
                                            Case ParamMem Or ParamReg, ParamMem:
                                                If Not Instructions(j).ModRM And .PType = ParamMem Then
                                                    size = size + 4     ' Imm
                                                Else
                                                    If m_udtInstrs(i).args(k).Pointer.HasDisplacement Then
                                                        size = size + m_udtInstrs(i).args(k).Pointer.DispSize \ 8
                                                    End If
                                                    
                                                    If m_udtInstrs(i).args(k).Pointer.RegisterCount = 2 Or _
                                                       m_udtInstrs(i).args(k).Pointer.RegisterMultiples Then
                                                        size = size + 1 ' SIB
                                                    End If
                                                End If
                                                
                                        End Select
                                        
                                    End If
                                End With
                            Next
                        End If
                        
                        m_udtInstrs(i).OpCodeIndex = j
                        m_udtInstrs(i).size = size
                        Exit For
                    End If
                End If
            Next
            
            If j = InstructionCount Then
                If blnFoundI Then
                    SetError "Ungltige Argumente", m_udtInstrs(i).Line, m_udtInstrs(i).Section
                Else
                    SetError "Unbekannter Befehl: " & m_udtInstrs(i).Mnemonic, m_udtInstrs(i).Line, m_udtInstrs(i).Section
                End If
                
                Exit Function
            End If
        End If
    Next
    
    FillInOffsets
    If m_blnWritePE Then
        m_lngPECodeSize = m_lngOutSize
        
        lngImpSz = GetNeededImportsSize()
        If lngImpSz = 0 Then
            m_lngOutSize = RoundToMinSize(GetPEHeaderSize()) + _
                           RoundToMinSize(m_lngPECodeSize) + _
                           RoundToMinSize(1)
        Else
            m_lngOutSize = RoundToMinSize(GetPEHeaderSize()) + _
                           RoundToMinSize(m_lngPECodeSize) + _
                           RoundToMinSize(lngImpSz)
        End If
        
        FillInIAT RoundToSectionSize(GetPEHeaderSize()) + _
                  RoundToSectionSize(m_lngPECodeSize)
    End If

    ReDim m_btOutput(m_lngOutSize - 1) As Byte

    GetInstructionSizes = True
End Function


' Label- und Instruktionsoffsets berechnen
Private Sub FillInOffsets()
    Dim i           As Long
    Dim j           As Long
    Dim lngPEOffset As Long
    
    If m_blnWritePE Then
        lngPEOffset = RoundToSectionSize(GetPEHeaderSize)
    End If
    
    For i = 0 To m_lngInstrCount - 1
        m_udtInstrs(i).Offset = m_lngOutSize + m_lngBaseAddress + lngPEOffset
        m_lngOutSize = m_lngOutSize + m_udtInstrs(i).size

        If j < m_lngLabelCount Then
            Do While m_udtLabels(j).Instruction = i
                m_udtLabels(j).Offset = m_udtInstrs(i).Offset
                j = j + 1
                If j = m_lngLabelCount Then Exit Do
            Loop
        End If
    Next
    
    If j < m_lngLabelCount Then
        With m_udtInstrs(m_lngInstrCount - 1)
            For j = j To m_lngLabelCount - 1
                m_udtLabels(j).Offset = .Offset
            Next
        End With
    End If
End Sub


' Sprungadressen fr importierte Funktionen berechnen
Private Sub FillInIAT(ByVal reladdr As Long)
    Dim i           As Long
    Dim j           As Long
    Dim k           As Long
    Dim libidx      As Long
    Dim fncidx      As Long
    
    For i = 0 To m_lngInstrCount - 1
        For j = 0 To m_udtInstrs(i).argcount - 1
            If (m_udtInstrs(i).args(j).TType And ParamExt) Then
                libidx = (m_udtInstrs(i).args(j).SymbolIndex \ &H10000) And &HFFFF&
                fncidx = m_udtInstrs(i).args(j).SymbolIndex And &HFFFF&
                m_udtInstrs(i).args(j).Pointer.ptr.Displacement = GetExternRelOfFnc(libidx, fncidx, reladdr)
            End If
        Next
    Next
End Sub


' Geparste Instruction mit einer aus dem Instruction Set vergleichen
Private Function CompareInstrs( _
    src As ASMInstruction, _
    comp As Instruction _
) As Boolean

    Dim i               As Long
    
    If src.argcount = comp.ParamCount Then
        For i = 0 To src.argcount - 1
            ' Imm und Rel sollen gleichwertig behandelt werden
            With comp.Parameters(i)
                If (.PType And src.args(i).TType) = 0 Then
                    If Not (.PType = ParamImm And src.args(i).TType = ParamRel) Then
                        If Not (.PType = ParamRel And src.args(i).TType = ParamImm) Then
                            Exit Function
                        End If
                    End If
                End If
            End With
            
            If comp.Parameters(i).Forced Then
                Select Case comp.Parameters(i).PType
                    Case ParamReg:
                        If src.args(i).Register <> comp.Parameters(i).Register Then
                            Exit Function
                        End If
                    Case ParamSTX:
                        If src.args(i).FPURegister <> comp.Parameters(i).FPURegister Then
                            Exit Function
                        End If
                    Case ParamImm:
                        If src.args(i).Value <> comp.Parameters(i).Value Then
                            Exit Function
                        End If
                End Select
            Else
                If comp.Parameters(i).PType = ParamMem Then
                    If Not comp.ModRM Then
                        If src.args(i).Pointer.RegisterCount > 0 Then
                            ' Instruktion darf keine Register im Pointer haben,
                            ' weil kein ModR/M Byte vorgesehen ist
                            Exit Function
                        End If
                    End If
                ElseIf (comp.Parameters(i).PType And ParamMM) Then
                    If IsDefinite(comp.Parameters(i).MMRegister) Then
                        If comp.Parameters(i).MMRegister <> src.args(i).MMRegister Then
                            Exit Function
                        End If
                    Else
                        If src.args(i).TType = ParamMem Then
                            If (comp.Parameters(i).PType And ParamMem) = 0 Then
                                Exit Function
                            End If
                        Else
                            If (comp.Parameters(i).MMRegister And src.args(i).MMRegister) = 0 Then
                                Exit Function
                            End If
                        End If
                    End If
                End If
            End If
            
            If (comp.Parameters(i).size And src.args(i).size) = 0 Then
                If comp.Parameters(i).size <> BitsUnknown Then
                    Exit Function
                End If
            End If
        Next
        
        CompareInstrs = True
    End If
End Function


' Labels sammeln
Private Function FindLabels() As Boolean
    Dim i           As Long
    Dim lngInstrCnt As Long
    
    For i = 1 To m_lngTokenCount - 2
        If m_clsTokens(i).TType = ASMTokenSymbol Then
            If m_clsTokens(i + 1).TType = ASMTokenOpColon Then
                If GetLabelIndex(m_clsTokens(i).Content) > -1 Then
                    SetError "Nicht eindeutiges Label: " & m_clsTokens(i).Content, m_clsTokens(i).Line, m_clsTokens(i).Section
                    Exit Function
                End If
                AddLabel m_clsTokens(i).Content, lngInstrCnt
            End If
        ElseIf m_clsTokens(i).TType = ASMTokenOperator Then
            lngInstrCnt = lngInstrCnt + 1
        ElseIf m_clsTokens(i).TType = ASMTokenRawData Then
            lngInstrCnt = lngInstrCnt + 1
        End If
    Next
    
    FindLabels = True
End Function


' berspringt Labels, da die schon vorher eingelesen wurden.
' Verarbeitet nur Instruktionen.
Private Function ParseInstructions() As Boolean
    If Not Match(ASMTokenBeginOfInput) Then
        SetError "Unbekannter Fehler whrend Parserinitialisierung", 0, ""
    Else
        Do While Token.TType <> ASMTokenEndOfInput
            Select Case Token.TType
            
                Case ASMTokenExtern:
                    If m_blnWritePE Then
                        Match ASMTokenExtern
                        If Not ParseExtern() Then Exit Do
                    Else
                        SetError "Externs nur im PE Modus erlaubt", Token.Line, Token.Section
                        Exit Function
                    End If
            
                Case ASMTokenSymbol:
                    Match ASMTokenSymbol
                    If Not Match(ASMTokenOpColon) Then
                        SetError """:"" nach Label ID erwartet", Token.Line, Token.Section
                        Exit Do
                    End If
                    
                Case ASMTokenOperator, ASMTokenKeyword:
                    If Not ParseInstruction Then Exit Do
                    
                Case ASMTokenRawData:
                    If Not ParseRawData Then Exit Do
                    
                Case Else:
                    If Token.TType <> ASMTokenEndOfInstruction Then
                        SetError "Unerwartetes Symbol: " & Token.Content, Token.Line, Token.Section
                        Exit Do
                    End If
                    
            End Select
            
            If Not Match(ASMTokenEndOfInstruction) Then
                SetError "Unerwartetes Ende", Token.Line, Token.Section
                Exit Do
            Else
                ParseInstructions = Token.TType = ASMTokenEndOfInput
            End If
        Loop
    End If
End Function


Private Function AddExtern(ByVal lib As String, ByVal fnc As String) As Boolean
    Dim i   As Long
    Dim j   As Long
    
    AddExtern = True
    
    For i = 0 To m_lngExternCount - 1
        If StrComp(m_udtExtern(i).LibName, lib, vbTextCompare) = 0 Then
            For j = 0 To m_udtExtern(i).FunctionCount - 1
                If StrComp(m_udtExtern(i).Functions(j), fnc, vbTextCompare) = 0 Then
                    Exit Function
                End If
            Next
            
            With m_udtExtern(i)
                ReDim Preserve .Functions(.FunctionCount) As String
                .Functions(.FunctionCount) = fnc
                .FunctionCount = .FunctionCount + 1
            End With
            Exit Function
        End If
    Next
    
    If i = m_lngExternCount Then
        ReDim Preserve m_udtExtern(m_lngExternCount) As ASMExtern
        
        With m_udtExtern(m_lngExternCount)
            .LibName = lib
            
            ReDim .Functions(0) As String
            .Functions(0) = fnc
            .FunctionCount = 1
        End With
        
        m_lngExternCount = m_lngExternCount + 1
    End If
End Function


Private Function ParseExtern() As Boolean
    Dim strLib  As String
    Dim strFnc  As String
        
    If Token.TType <> ASMTokenString Then
        SetError "String Identifier fr Bibliotheksname erwartet", Token.Line, Token.Section
        Exit Function
    Else
        strLib = Token.Content
        Match ASMTokenString
        
        If Not Match(ASMTokenSeparator) Then
            SetError "Bibliotheksname und Funktionsname mssen durch ein "","" getrennt sein", Token.Line, Token.Section
            Exit Function
        Else
            If Token.TType <> ASMTokenSymbol Then
                SetError "Symbolname der exportierten Funktion erwartet", Token.Line, Token.Section
                Exit Function
            Else
                strFnc = Token.Content
                Match ASMTokenSymbol
                
                If GetLabelIndex(strFnc) > -1 Then
                    SetError "Name nicht eindeutig", Token.Line, Token.Section
                Else
                    ParseExtern = AddExtern(strLib, strFnc)
                End If
            End If
        End If
    End If
End Function


Private Function ParseRawData() As Boolean
    Dim udtInstr    As ASMInstruction
    Dim i           As Long
    Dim lngLen      As Long
    Dim lngTemp     As Long
    
    Select Case UCase$(Token.Content)
        Case "DB":  udtInstr.Data.size = Bits8
        Case "DW":  udtInstr.Data.size = Bits16
        Case "DD":  udtInstr.Data.size = Bits32
    End Select
    Match ASMTokenRawData
    
    With udtInstr.Data
        Do
            Select Case Token.TType
                Case ASMTokenValue:
                    ReDim Preserve .Values(.ValueCount) As Long
                    .Values(.ValueCount) = Token.Value
                    .ValueCount = .ValueCount + 1
                    Match ASMTokenValue
                    
                Case ASMTokenString:
                    lngTemp = .ValueCount
                    
                    ReDim Preserve .Values(.ValueCount + Len(Token.Content) - 1) As Long
                    For i = 1 To Len(Token.Content)
                        .Values(lngTemp + i - 1) = Asc(Mid$(Token.Content, i, 1))
                    Next
                    
                    .ValueCount = .ValueCount + Len(Token.Content)
                    Match ASMTokenString
                    
                Case Else:
                    SetError "Unerwartetes Token: " & Token.Content, udtInstr.Line, udtInstr.Section
                    Exit Function
                    
            End Select
        Loop While Match(ASMTokenSeparator)
    End With
    
    AddInstruction udtInstr
    
    ParseRawData = True
End Function


Private Function ParseInstruction() As Boolean
    Dim udtInstr    As ASMInstruction
    
    ' Instruktion kann mehrere Schlsselwrter wie "lock rep" haben
    Do While Token.TType = ASMTokenKeyword
        Select Case UCase$(Token.Content)
            Case "REP":     udtInstr.flags = udtInstr.flags Or PrefixFlgRep
            Case "REPE":    udtInstr.flags = udtInstr.flags Or PrefixFlgRepe
            Case "REPZ":    udtInstr.flags = udtInstr.flags Or PrefixFlgRepz
            Case "REPNE":   udtInstr.flags = udtInstr.flags Or PrefixFlgRepne
            Case "REPNZ":   udtInstr.flags = udtInstr.flags Or PrefixFlgRepnz
            Case "LOCK":    udtInstr.flags = udtInstr.flags Or PrefixFlgLock
            Case Else:      SetError "Unbekanntes Schlsselwort: " & Token.Content, Token.Line, Token.Section
                            Exit Function
        End Select
        
        Match ASMTokenKeyword
    Loop
    
    If Token.TType <> ASMTokenOperator Then
        SetError "Operator erwartet", Token.Line, Token.Section
    Else
        udtInstr.Mnemonic = Token.Content
        udtInstr.Line = Token.Line
        udtInstr.Section = Token.Section
        
        Match ASMTokenOperator
        
        If ParseArguments(udtInstr) Then
            AddInstruction udtInstr
            ParseInstruction = True
        End If
    End If
End Function


' Liest bis zu 3 Argumente pro Instruktion ein.
' Erst wird auf Schlsselwrter geprft, darauf kann dann
' ein Label, ein numerischer Wert, ein FPU/Segment/Allzweckregister
' oder ein Pointer (mit SIB Untersttzung) folgen.
Private Function ParseArguments(udtInstr As ASMInstruction) As Boolean
    Dim lngArgs     As Long
    Dim lngPtrIdx   As Long
    Dim blnCont     As Boolean
    
    lngPtrIdx = -1
    
    Do
        If lngArgs = 3 Then
            SetError "Zu viele Argumente", udtInstr.Line, udtInstr.Section
            Exit Function
        End If
        
        If Token.TType = ASMTokenKeyword Then
            If Not ParseKeywords(udtInstr, lngArgs) Then Exit Function
        End If
        
        blnCont = False
        Select Case Token.TType
            Case ASMTokenRegister:
                If Not ParseArgumentRegister(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
            Case ASMTokenFPUReg:
                If Not ParseArgumentFPUReg(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
            Case ASMTokenMMRegister:
                If Not ParseArgumentMMReg(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
            Case ASMTokenSymbol:
                If Not ParseArgumentSymbol(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
            Case ASMTokenValue:
                If Not ParseArgumentValue(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
            Case ASMTokenBracketLeft:
                If Not ParseArgumentPtr(udtInstr, udtInstr.args(lngArgs)) Then Exit Function
                lngPtrIdx = lngArgs
            Case ASMTokenSegmentReg:
                If Not ParseSegmentReg(udtInstr) Then Exit Function
                blnCont = True
            Case ASMTokenEndOfInstruction:
                Exit Do
            Case Else:
                SetError "Unberwartetes Symbol: " & Token.Content, udtInstr.Line, udtInstr.Section
                Exit Function
        End Select
        
        If Not blnCont Then lngArgs = lngArgs + 1
    Loop While Match(ASMTokenSeparator) Or blnCont
    
    If lngPtrIdx > -1 Then
        If udtInstr.args(lngPtrIdx).size = BitsUnknown Then
            If lngArgs = 2 Then
                If IsDefinite(udtInstr.args(1 - lngPtrIdx).size) Or _
                   (udtInstr.args(1 - lngPtrIdx).TType And ParamMM) Then
                    udtInstr.args(lngPtrIdx).size = udtInstr.args(1 - lngPtrIdx).size
                Else
                    SetError "Unbekannte Zeigergre", udtInstr.Line, udtInstr.Section
                    Exit Function
                End If
'            Else
'                SetError "Unbekannte Zeigergre", udtInstr.Line
'                Exit Function
            End If
        End If
    End If
    
    udtInstr.argcount = lngArgs
    ParseArguments = True
End Function


Private Function ParseArgumentPtr( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    arg.TType = ParamMem
    arg.Pointer.TokenIndex = m_lngCurToken
    ParseArgumentPtr = ValidatePointer(udtInstr, arg.Pointer)
End Function


Private Function ParseArgumentValue( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    arg.TType = ParamImm
    arg.Value = Token.Value
    
    If arg.size = BitsUnknown Then
        arg.size = SizesForInt(Token.Value)
    Else
        If (arg.size And SizesForInt(Token.Value)) = 0 Then
            SetError "Inkompatible Integergren", udtInstr.Line, udtInstr.Section
            Exit Function
        End If
    End If
    
    Match ASMTokenValue
    ParseArgumentValue = True
End Function


Private Function ParseArgumentSymbol( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    Dim lngLblIdx   As Long
    Dim blnExtern   As Boolean
    
    lngLblIdx = GetLabelIndex(Token.Content)
    If lngLblIdx = -1 Then
        lngLblIdx = GetExternIndex(Token.Content)
        If lngLblIdx = -1 Then
            SetError "Unbekannte Marke: " & Token.Content, udtInstr.Line, udtInstr.Section
            Exit Function
        Else
            blnExtern = True
        End If
    End If
    
    If blnExtern Then
        arg.TType = ParamMem Or ParamExt
        arg.SymbolIndex = lngLblIdx
        arg.size = Bits32
        
        arg.Pointer.HasDisplacement = True
        arg.Pointer.ptr.DispSize = Bits32
        arg.Pointer.DispSize = Bits32
    Else
        arg.TType = ParamRel
        arg.SymbolIndex = lngLblIdx
        
        If arg.size = BitsUnknown Then
            arg.size = Bits32 Or Bits16 Or Bits8
        End If
    End If
    
    Match ASMTokenSymbol
    ParseArgumentSymbol = True
End Function


Private Function ParseArgumentMMReg( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    arg.TType = ParamMM
    arg.MMRegister = MMRegStrToNum(Token.Content)
    
    If arg.size <> BitsUnknown Then
        If (arg.size And (Bits32 Or Bits64 Or Bits80 Or Bits128)) = 0 Then
            SetError "Inkompatible Grenangaben", udtInstr.Line, udtInstr.Section
            Exit Function
        End If
    Else
        If (arg.MMRegister < XMM0) Then
            arg.size = Bits64
        Else
            arg.size = Bits128
        End If
    End If
    
    Match ASMTokenMMRegister
    ParseArgumentMMReg = True
End Function


Private Function ParseArgumentFPUReg( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    arg.TType = ParamSTX
    arg.FPURegister = FPURegStrToNum(Token.Content)
    
    If arg.size <> BitsUnknown Then
        If (arg.size And (Bits32 Or Bits64 Or Bits80)) = 0 Then
            SetError "Inkompatible Grenangaben", udtInstr.Line, udtInstr.Section
            Exit Function
        End If
    Else
        arg.size = Bits32 Or Bits64 Or Bits80
    End If
    
    Match ASMTokenFPUReg
    ParseArgumentFPUReg = True
End Function


Private Function ParseArgumentRegister( _
    udtInstr As ASMInstruction, _
    arg As ASMArgument _
) As Boolean

    arg.TType = ParamReg
    arg.Register = RegStrToReg(Token.Content)
    
    If arg.size <> BitsUnknown Then
        If arg.size <> RegisterSize(arg.Register) Then
            SetError "Inkompatible Grenangaben", udtInstr.Line, udtInstr.Section
            Exit Function
        End If
    Else
        arg.size = RegisterSize(arg.Register)
    End If
    
    Match ASMTokenRegister
    ParseArgumentRegister = True
End Function


' alle an dieser Stelle zulssigen Schlsselwrter sind nur Grenangaben,
' deswegen ist nur ein einziges erlaubt. "byte dword" z.B. verursacht einen
' Fehler bei "dword".
Private Function ParseKeywords( _
    udtInstr As ASMInstruction, _
    argidx As Long _
) As Boolean

    Select Case UCase$(Token.Content)
        Case "BYTE":                udtInstr.args(argidx).size = Bits8
        Case "WORD":                udtInstr.args(argidx).size = Bits16
        Case "DWORD", "FLOAT":      udtInstr.args(argidx).size = Bits32
        Case "QWORD", "DOUBLE":     udtInstr.args(argidx).size = Bits64
        Case "EXTENDED":            udtInstr.args(argidx).size = Bits80
        Case "DQWORD":              udtInstr.args(argidx).size = Bits128
        Case Else:                  SetError "An dieser Stelle ungltiges Symbol", udtInstr.Line, udtInstr.Section
                                    Exit Function
    End Select
    
    Match ASMTokenKeyword
    ParseKeywords = True
End Function


Private Function ValidatePointer( _
    udtInstr As ASMInstruction, _
    ptr As PointerInfo _
) As Boolean

    If Not Match(ASMTokenBracketLeft) Then
        SetError "Erwartet: [", udtInstr.Line, udtInstr.Section
    Else
        If ValidateExpr(udtInstr, ptr) Then
            If Not Match(ASMTokenBracketRight) Then
                SetError """["" erwartet", udtInstr.Line, udtInstr.Section
            Else
                ValidatePointer = True
            End If
        End If
    End If
End Function


' Expression innerhalb von Brackets auswerten ( "[eax*2+ebp-10]" )
Private Function ValidateExpr( _
    udtInstr As ASMInstruction, _
    ptr As PointerInfo _
) As Boolean

    Dim lngRegCount(REG_COUNT - 1)  As Long
    Dim lngUsedRegs(1)              As Long
    Dim lngDisplacement             As Long
    Dim lngSign                     As Long
    Dim lngReg                      As Long
    Dim lngTms                      As Long
    Dim i                           As Long
    Dim blnHasSymbols               As Boolean
    Dim blnHasSymbol                As Boolean
    Dim blnHasRegister              As Boolean
    
    If Match(ASMTokenOpAdd) Then
        lngSign = 1
    ElseIf Match(ASMTokenOpSub) Then
        lngSign = -1
    Else
        lngSign = 1
    End If
    
    Do
        lngTms = 1
        blnHasSymbol = False
        blnHasRegister = False
        
        Do
            Select Case Token.TType
                Case ASMTokenRegister:
                    If blnHasRegister Then
                        SetError "Potenzierung von Registern nicht mglich", udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                    
                    If blnHasSymbol Then
                        SetError "Register*Label ungltig", udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                    
                    If RegStrToReg(Token.Content) < RegEAX Then
                        SetError "Nur 32 Bit Register in Pointer erlaubt", udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                    
                    lngReg = RegToIdx(RegStrToReg(Token.Content))
                    blnHasRegister = True
                    Match ASMTokenRegister
                
                Case ASMTokenValue:
                    lngTms = lngTms * Token.Value
                    Match ASMTokenValue
                
                Case ASMTokenSymbol:
                    If blnHasRegister Then
                        SetError "Register*Label ungltig", udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                    
                    If GetLabelIndex(Token.Content) = -1 Then
                        SetError "Unbekanntes Symbol: " & Token.Content, udtInstr.Line, udtInstr.Section
                        Exit Function
                    End If
                                        
                    blnHasSymbol = True
                    blnHasSymbols = True
                    Match ASMTokenSymbol
                
                Case Else:
                    SetError "In Pointer ungltiges Symbol: " & Token.Content, udtInstr.Line, udtInstr.Section
                    Exit Function
                    
            End Select
        Loop While Match(ASMTokenOpMul)
        
        If blnHasRegister Then
            lngRegCount(lngReg) = lngRegCount(lngReg) + lngSign * lngTms
        Else
            lngDisplacement = lngDisplacement + lngSign * lngTms
        End If
        
        If Match(ASMTokenOpAdd) Then
            lngSign = 1
        ElseIf Match(ASMTokenOpSub) Then
            lngSign = -1
        Else
            Exit Do
        End If
    Loop
    
    For i = 0 To REG_COUNT - 1
        If lngRegCount(i) > 0 Then
            If lngRegCount(i) > 1 Then
                ' Register ist vielfaches
                ptr.RegisterMultiples = True
            Else
                ' Bei ESP muss SIB Byte geschrieben werden,
                ' InstructionOutArgs() macht das auch abhngig von RegisterMultiples,
                ' also hier einfach vortuschen.
                If IdxToReg(i) = RegESP Then ptr.RegisterMultiples = True
            End If
            
            ptr.RegisterCount = ptr.RegisterCount + 1
            If ptr.RegisterCount > 2 Then Exit For
            lngUsedRegs(ptr.RegisterCount - 1) = lngRegCount(i)
            
        ElseIf lngRegCount(i) < 0 Then
            SetError "Negatives Register-Vielfaches", udtInstr.Line, udtInstr.Section
            Exit Function
            
        End If
    Next
    
    If blnHasSymbols Then
        ptr.HasDisplacement = True
        ptr.DispSize = Bits32
    Else
        If lngDisplacement <> 0 Then
            ptr.HasDisplacement = True
            ptr.DispSize = GetFirstSetBit(SizesForInt(lngDisplacement))
            If ptr.DispSize > Bits8 Then
                ' Bits16 nicht mglich wegen ModR/M
                ptr.DispSize = Bits32
            End If
        Else
            If lngRegCount(RegToIdx(RegEBP)) > 0 Then
                If ptr.RegisterCount = 1 Then
                    ' EBP kann nur mit Displacement kodiert werden,
                    ' also einfach genulltes 8 Bit Displacement hinzufgen
                    ptr.HasDisplacement = True
                    ptr.DispSize = Bits8
                End If
            Else
                ptr.HasDisplacement = False
                ptr.DispSize = BitsUnknown
            End If
        End If
    End If
    
    If ptr.RegisterCount = 1 Then
        If (lngUsedRegs(0) = 4) Or (lngUsedRegs(0) = 8) Then
            ' Reg*4/8 muss mit SIB kodiert werden,
            ' es gibt in diesem Fall aber kein Base Reg (ptr.RegisteCount = 1),
            ' deswegen ist 32 Bit Displacement ntig
            ptr.HasDisplacement = True
            ptr.DispSize = Bits32
        End If
    End If
    
    If ptr.RegisterCount > 2 Then
        SetError "Mehr als 2 Register pro Pointer nicht erlaubt", udtInstr.Line, udtInstr.Section
    Else
        ptr.ptr.UsedRegisters = ptr.RegisterCount
        ptr.ptr.DispSize = ptr.DispSize
        ValidateExpr = True
    End If
End Function


Private Function ParseSegmentReg(udtInstr As ASMInstruction) As Boolean
    If udtInstr.Segment <> SegUnknown Then
        SetError "Pro Instruktion nur eine nderung des Segments", udtInstr.Line, udtInstr.Section
    Else
        udtInstr.Segment = SegStrToSeg(Token.Content)
        Match ASMTokenSegmentReg
     
        If Match(ASMTokenOpColon) Then
            ParseSegmentReg = True
        Else
            SetError "Doppelpunkt nach Segment Register ewartet", udtInstr.Line, udtInstr.Section
        End If
    End If
End Function


Private Sub AddInstruction(udtInstr As ASMInstruction)
    ReDim Preserve m_udtInstrs(m_lngInstrCount) As ASMInstruction
    m_udtInstrs(m_lngInstrCount) = udtInstr
    m_lngInstrCount = m_lngInstrCount + 1
End Sub


Private Function GetExternIndex(Name As String) As Long
    Dim i   As Long
    Dim j   As Long
    
    For i = 0 To m_lngExternCount - 1
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            If StrComp(m_udtExtern(i).Functions(j), Name, vbTextCompare) = 0 Then
                GetExternIndex = i * &H10000 Or j
                Exit Function
            End If
        Next
    Next
    
    GetExternIndex = -1
End Function


Private Function GetExternRelOfFnc(ByVal libidx As Long, ByVal fncidx As Long, ByVal reladdr As Long) As Long
    Dim i   As Long
    Dim j   As Long
    Dim sz  As Long
    
    For i = 0 To libidx - 1
        sz = sz + 4 * (m_udtExtern(i).FunctionCount + 1)
    Next
    sz = sz + 4 * fncidx
    
    GetExternRelOfFnc = sz + m_lngBaseAddress + reladdr
End Function


Private Function GetILTLibStart(ByVal index As Long) As Long
    Dim im  As IMAGE_IMPORT_DIRECTORY
    Dim sz  As Long
    
    sz = GetNeededIATSize() + GetIATLibStart(index)
    sz = sz + Len(im) * (m_lngExternCount + 1)
    
    GetILTLibStart = sz
End Function


Private Function GetIATLibStart(ByVal index As Long) As Long
    Dim i   As Long
    Dim sz  As Long
    
    For i = 0 To index - 1
        sz = sz + 4 * (m_udtExtern(i).FunctionCount + 1)
    Next
    
    GetIATLibStart = sz
End Function


Private Function GetNeededIATSize() As Long
    Dim i   As Long
    Dim sz  As Long
    
    For i = 0 To m_lngExternCount - 1
        sz = sz + 4 * (m_udtExtern(i).FunctionCount + 1)
    Next
    
    GetNeededIATSize = sz
End Function


Private Function GetNeededImportsSize() As Long
    Dim i   As Long
    Dim j   As Long
    Dim sz  As Long
    Dim im  As IMAGE_IMPORT_DIRECTORY
    
    For i = 0 To m_lngExternCount - 1
        sz = sz + EvenSize(Len(m_udtExtern(i).LibName) + 1)
        sz = sz + Len(im)
        
        For j = 0 To m_udtExtern(i).FunctionCount - 1
            sz = sz + EvenSize(Len(m_udtExtern(i).Functions(j)) + 1) + 2
            sz = sz + 4 * 2
        Next
        
        sz = sz + 4 * 2
    Next
    
    If m_lngExternCount > 0 Then
        sz = sz + Len(im)
    End If
    
    GetNeededImportsSize = sz
End Function


Private Function RoundToSectionSize(ByVal lngVal As Long) As Long
    RoundToSectionSize = RoundTo(lngVal, MEM_SECTION_SIZE)
End Function


Private Function RoundToMinSize(ByVal lngVal As Long) As Long
    RoundToMinSize = RoundTo(lngVal, FILE_SECTION_SIZE)
End Function


Private Function RoundTo(ByVal lngVal As Long, ByVal lngMult As Long) As Long
    If lngVal Mod lngMult Then
        RoundTo = lngVal + (lngMult - lngVal Mod lngMult)
    Else
        RoundTo = lngVal
    End If
End Function


Private Function EvenSize(ByVal sz As Long) As Long
    EvenSize = sz + (sz Mod 2)
End Function


Private Function HexToByte(ByVal strHex As String) As Byte()
    Dim bt()    As Byte
    Dim i       As Long
    
    ReDim bt(Len(strHex) \ 2 - 1) As Byte
    
    For i = 1 To Len(strHex) Step 2
        bt((i - 1) \ 2) = CByte("&H" & Mid$(strHex, i, 2))
    Next
    
    HexToByte = bt
End Function


Private Function GetLabelIndex(Name As String) As Long
    Dim i   As Long
    
    For i = 0 To m_lngLabelCount - 1
        If StrComp(m_udtLabels(i).Name, Name, vbTextCompare) = 0 Then
            GetLabelIndex = i
            Exit Function
        End If
    Next
    
    GetLabelIndex = -1
End Function


Private Sub SetError(ByVal strMsg As String, ByVal lngLine As Long, ByVal Section As String)
    m_strLastError = strMsg
    m_lngLastErrLine = lngLine
    m_strLastErrorSection = Section
End Sub


' Match Funktion fr Durchgehen durch Tokens nach TokenizeInput()
Private Function Match(ByVal tp As ASMTokenType) As Boolean
    If m_clsTokens(m_lngCurToken).TType = tp Then
        m_lngCurToken = m_lngCurToken + 1
        Match = True
    End If
End Function


' Token Property fr Zugriff auf aktuelles Token nach TokenizeInput()
Private Property Get Token() As ASMToken
    Set Token = m_clsTokens(m_lngCurToken)
End Property


' Sammelt alle Tokens und fhrt Vorzeichen und Zahlen zusammen
Private Sub TokenizeInput()
    Dim blnInPtr    As Boolean
    Dim clsMinus    As ASMToken
    
    Do
        If clsMinus Is Nothing Then
            AddToken ScannerToken
        End If
        
        If ScannerToken.TType = ASMTokenEndOfInput Then
            Exit Do
        Else
            ScannerGetNextToken
            Select Case ScannerToken.TType
                Case ASMTokenBracketLeft:
                    blnInPtr = True
                Case ASMTokenBracketRight:
                    blnInPtr = False
                Case ASMTokenOpSub:
                    If Not blnInPtr Then Set clsMinus = ScannerToken
                Case ASMTokenValue:
                    If Not clsMinus Is Nothing Then
                        ScannerToken.Value = -ScannerToken.Value
                        Set clsMinus = Nothing
                    End If
                Case Else:
                    If Not clsMinus Is Nothing Then
                        AddToken clsMinus
                        Set clsMinus = Nothing
                    End If
            End Select
        End If
    Loop
End Sub


Private Sub AddLabel(strName As String, ByVal lngInstr As Long)
    ReDim Preserve m_udtLabels(m_lngLabelCount) As ASMLabel
    
    With m_udtLabels(m_lngLabelCount)
        .Name = strName
        .Instruction = lngInstr
        .Offset = 0
    End With
    
    m_lngLabelCount = m_lngLabelCount + 1
End Sub


Private Sub AddToken(ByVal clsTk As ASMToken)
    ReDim Preserve m_clsTokens(m_lngTokenCount) As ASMToken
    Set m_clsTokens(m_lngTokenCount) = clsTk
    m_lngTokenCount = m_lngTokenCount + 1
End Sub


'#########################################################
'#########################################################
' Scanner Funktionen

Private Function ScannerMatch(udeType As ASMTokenType) As Boolean
    If m_udtScanner.CurToken.TType = udeType Then
        ScannerGetNextToken
        ScannerMatch = True
    End If
End Function


Private Property Get ScannerToken() As ASMToken
    Set ScannerToken = m_udtScanner.CurToken
End Property


Private Sub ScannerInit(Source As String)
    With m_udtScanner
        .Source = StrConv(Source & vbCrLf, vbFromUnicode)
        .Length = UBound(.Source) + 1
    
        .Position = 0
        .Line = 1
        .LinePos = 0
        .NextIsEOI = False
        .LastWasEOI = True
        .Section = "main"
    
        Set .NextToken = New ASMToken
        With .NextToken
            .TType = ASMTokenBeginOfInput
            .Line = 1
            .Position = 0
        End With
    
        ScannerGetNextToken
    End With
End Sub


Private Sub ScannerGetNextToken()
    Dim clsToken    As ASMToken
    
    Set clsToken = New ASMToken
    Set m_udtScanner.CurToken = m_udtScanner.NextToken
    
    If m_udtScanner.NextIsEOI Then
        clsToken.TType = ASMTokenEndOfInstruction
        m_udtScanner.NextIsEOI = False
        m_udtScanner.LastWasEOI = True
    Else
        With m_udtScanner
            Do While (.Position < .Length) And (clsToken.TType = ASMTokenUnknown)
                Select Case .Source(.Position)
                
                    Case CHAR_SPACE:
                        ' nichts tun
                        
                    Case CHAR_CARRIAGE:
                        clsToken.TType = ASMTokenEndOfInstruction
                    
                    Case CHAR_VERT_BAR:
                        .Line = .Line + 1
                        .LinePos = .LinePos + 1
                        clsToken.TType = ASMTokenEndOfInstruction

                    Case CHAR_LINEFEED:
                        .Line = .Line + 1
                        .LinePos = .LinePos + 1
                        
                    Case CHAR_SHARP:
                        .Section = ""
                        .Line = 0
                        .LinePos = 0
                        .Position = .Position + 1
                        
                        Do
                            .Section = .Section & ChrW$(.Source(.Position))
                            .Position = .Position + 1
                        Loop While .Source(.Position) <> CHAR_CARRIAGE
                        
                        .Position = .Position - 1
                        
                    Case CHAR_SEMICOLON:
                        Do
                            .Position = .Position + 1
                        Loop While .Source(.Position + 1) <> CHAR_CARRIAGE And _
                                   .Source(.Position + 1) <> CHAR_VERT_BAR
                            
                    Case CHAR_SEPARATOR:
                        clsToken.TType = ASMTokenSeparator
                        clsToken.Content = ","
                        
                    Case CHAR_COLON:
                        clsToken.TType = ASMTokenOpColon
                        clsToken.Content = ":"
                        
                    Case CHAR_PLUS:
                        clsToken.TType = ASMTokenOpAdd
                        clsToken.Content = "+"
                    
                    Case CHAR_MINUS:
                        clsToken.TType = ASMTokenOpSub
                        clsToken.Content = "-"
                    
                    Case CHAR_ASTERISK:
                        clsToken.TType = ASMTokenOpMul
                        clsToken.Content = "*"
                    
                    Case CHAR_BRACKET_L:
                        clsToken.TType = ASMTokenBracketLeft
                        clsToken.Content = "["
                    
                    Case CHAR_BRACKET_R:
                        clsToken.TType = ASMTokenBracketRight
                        clsToken.Content = "]"
                    
                    Case CHAR_NUMBER_0 To CHAR_NUMBER_9:
                        Do
                            clsToken.Content = clsToken.Content & ChrW$(.Source(.Position))
                            .Position = .Position + 1
                        Loop While IsDigit(.Source(.Position))
                        
                        clsToken.TType = ASMTokenValue
                        .Position = .Position - 1
                        
                    Case CHAR_AMPERSAND:
                        Select Case ChrW$(.Source(.Position + 1))
                        
                            Case "H", "O":
                                clsToken.Content = "&"
                                .Position = .Position + 1
                                
                                Do
                                    clsToken.Content = clsToken.Content & ChrW$(.Source(.Position))
                                    .Position = .Position + 1
                                Loop While IsHexChar(.Source(.Position))
                                
                                clsToken.TType = ASMTokenValue
                                .Position = .Position - 1
                                
                            Case Else:
                                clsToken.TType = ASMTokenInvalid
                                clsToken.Content = "&"
                                
                        End Select
                        
                    Case CHAR_QUOTE:
                        .Position = .Position + 1
                        Do While .Source(.Position) <> CHAR_QUOTE And _
                                 .Source(.Position) <> CHAR_CARRIAGE And _
                                 .Source(.Position) <> CHAR_LINEFEED
                        
                            clsToken.Content = clsToken.Content & ChrW$(.Source(.Position))
                            .Position = .Position + 1
                        Loop
                        clsToken.TType = ASMTokenString
                        
                    Case CHAR_ALPHA_UA To CHAR_ALPHA_UZ, CHAR_ALPHA_LA To CHAR_ALPHA_LZ:
                        Do
                            clsToken.Content = clsToken.Content & ChrW$(.Source(.Position))
                            .Position = .Position + 1
                        Loop While IsAlphaNumeric(.Source(.Position))
                        
                        If IsRegister(clsToken.Content) Then
                            clsToken.TType = ASMTokenRegister
                        ElseIf IsSegmentReg(clsToken.Content) Then
                            clsToken.TType = ASMTokenSegmentReg
                        ElseIf IsFPUReg(clsToken.Content) Then
                            clsToken.TType = ASMTokenFPUReg
                        ElseIf IsKeyword(clsToken.Content) Then
                            clsToken.TType = ASMTokenKeyword
                        ElseIf IsRawDataOp(clsToken.Content) Then
                            clsToken.TType = ASMTokenRawData
                        ElseIf IsMMReg(clsToken.Content) Then
                            clsToken.TType = ASMTokenMMRegister
                        ElseIf StrComp(clsToken.Content, "extern", vbTextCompare) = 0 Then
                            clsToken.TType = ASMTokenExtern
                        Else
                            clsToken.TType = ASMTokenSymbol
                        End If
                        
                        .Position = .Position - 1
                        
                    Case Else:
                        clsToken.TType = ASMTokenInvalid
                        clsToken.Content = ChrW$(.Source(.Position))
                        
                End Select
                
                If .Source(.Position) = CHAR_CARRIAGE Then
                    .LastWasEOI = True
                Else
                    If clsToken.TType <> ASMTokenKeyword And _
                       clsToken.TType <> ASMTokenSymbol And _
                       .Source(.Position) <> CHAR_SPACE Then
                        .LastWasEOI = False
                    End If
                End If
                
                .Position = .Position + 1
            Loop
        
            If (clsToken.TType = ASMTokenUnknown) And (.Position = .Length) Then
                clsToken.TType = ASMTokenEndOfInput
            End If
        End With
    End If
    
    ' ** Ist grade gescanntes Token ein ":", ist vorheriges Token ein Segmentregister
    '    oder ein Label. In dem Fall muss der ":" von einem Zeilenumbruch
    '    = Instruktionsende gefolgt werden, also unsichtbaren (m_blnNextIsEOI)
    '    Umbruch einfgen.
    ' ** Ist grade gescanntes Token eine Zeichenkette und letztes Token ein
    '    Zeilenumbruch oder Beginn des Inputstreams, ist grade gescanntes Token
    '    wahrscheinlich ein Operator. Kann aber auch von einem ":" gefolgt werden
    '    und dadurch beim nchsten GetNextToken() Call zum Label werden.
    ' ** Fr Zahlen (TokenValue) kann ASMToken.Content eine Dezimalzahl oder in
    '    VB Notation auch hexadezimale (&H...) oder oktale Werte (&O...) enthalten.
    With clsToken
        If .TType = ASMTokenOpColon Then
            If m_udtScanner.CurToken.TType = ASMTokenOperator Then
                m_udtScanner.CurToken.TType = ASMTokenSymbol
                m_udtScanner.NextIsEOI = True
                m_udtScanner.LastWasEOI = False
            End If
        ElseIf .TType = ASMTokenSymbol Then
            If m_udtScanner.CurToken.TType = ASMTokenEndOfInstruction Or _
               m_udtScanner.CurToken.TType = ASMTokenBeginOfInput Or _
               m_udtScanner.LastWasEOI Then
                .TType = ASMTokenOperator
                m_udtScanner.LastWasEOI = False
            End If
        ElseIf .TType = ASMTokenValue Then
            On Error Resume Next
            .Value = CLng(.Content)
            If Err Then .TType = ASMTokenInvalid
            On Error GoTo 0
        End If

        .Line = m_udtScanner.Line
        .Section = m_udtScanner.Section
        .Position = (m_udtScanner.Position - Len(.Content)) - m_udtScanner.LinePos + 1
    End With

    Set m_udtScanner.NextToken = clsToken
End Sub


Private Function IsDigit(ByVal bt As Byte) As Boolean
    IsDigit = (bt >= CHAR_NUMBER_0) And (bt <= CHAR_NUMBER_9)
End Function


Private Function IsHexChar(ByVal bt As Byte) As Boolean
    IsHexChar = ((bt >= CHAR_NUMBER_0) And (bt <= CHAR_NUMBER_9)) Or _
                ((bt >= CHAR_ALPHA_UA) And (bt <= CHAR_ALPHA_UA + 5)) Or _
                ((bt >= CHAR_ALPHA_LA) And (bt <= CHAR_ALPHA_LA + 5))
End Function


Private Function IsAlphaNumeric(ByVal bt As Byte) As Boolean
    IsAlphaNumeric = ((bt >= CHAR_NUMBER_0) And (bt <= CHAR_NUMBER_9)) Or _
                     ((bt >= CHAR_ALPHA_UA) And (bt <= CHAR_ALPHA_UZ)) Or _
                     ((bt >= CHAR_ALPHA_LA) And (bt <= CHAR_ALPHA_LZ)) Or _
                     (bt = CHAR_UNDERSCORE)
End Function


