Attribute VB_Name = "CallPtr"
Option Explicit

Private Declare Function CallProcGate Lib "user32" Alias "CallWindowProcA" ( _
    addr As Any, _
    ByVal raddr As Long, _
    ByVal argcount As Long, _
    ByVal args As Long, _
    Optional ByVal rsvd As Long = 0 _
) As Long

Public Enum CallingConvention
    CallStd
    CallCdecl
End Enum

Public Function CallProc( _
    ByVal addr As Long, _
    ByVal cv As CallingConvention, _
    ParamArray args() As Variant _
) As Long

    Static asm_std(7)   As Long, asm_cdecl(8)   As Long
    Dim lngArgs()       As Long, i              As Long
    Dim n               As Long, pArgs          As Long
    
    If asm_std(0) = 0 Then
        asm_std(0) = &H8B0C458B:    asm_cdecl(0) = &H8B0C458B
        asm_std(1) = &H5D8B104D:    asm_cdecl(1) = &H5D8B104D
        asm_std(2) = &H74C90914:    asm_cdecl(2) = &H74C90914
        asm_std(3) = &H4E9810B:     asm_cdecl(3) = &H4E9810B
        asm_std(4) = &HFF000000:    asm_cdecl(4) = &HFF000000
        asm_std(5) = &HF5751934:    asm_cdecl(5) = &HF5751934
        asm_std(6) = &H10C2D0FF:    asm_cdecl(6) = &H4D8BD0FF
        asm_std(7) = &HCCCCCC00:    asm_cdecl(7) = &HC2CC0110
                                    asm_cdecl(8) = &HCCCC0010
    End If
    
    n = UBound(args)
    
    If n >= 0 Then
        ReDim lngArgs(n) As Long
        For i = 0& To n
            lngArgs(i) = args(i)
        Next
        pArgs = VarPtr(lngArgs(0))
    End If
    
    If cv = CallStd Then
        CallProc = CallProcGate(asm_std(0), addr, n * 4 + 4, pArgs)
    ElseIf cv = CallCdecl Then
        CallProc = CallProcGate(asm_cdecl(0), addr, n * 4 + 4, pArgs)
    Else
        Err.Raise &H10000, , "Ungltige Aufrufkonvention!"
    End If
End Function
