Attribute VB_Name = "Helpers"
Option Explicit

Public Declare Sub CpyMem Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDst As Any, pSrc As Any, ByVal cLen As Long _
)

Public Const EXIT_PREFIX As String = "exit_"

Public Function ToStatementDim(ByVal cls As Object) As ParserStatementDim
    Set ToStatementDim = cls
End Function

Public Function ToIStatement(ByVal cls As Object) As IStatement
    Set ToIStatement = cls
End Function

Public Function CreateTempTACVar( _
    ByVal ctx As TACContext, _
    ByVal udeType As DATA_TYPE _
) As TACVar

    Set CreateTempTACVar = CreateTACVar(TAC_VARIABLE, _
                                        "t" & ctx.CreateTempID(), , _
                                        udeType)
End Function

Public Function CopyTACVar(ByVal cls As TACVar) As TACVar
    Dim clsNew As TACVar
    Set clsNew = New TACVar
    
    With clsNew
        .VarName = cls.VarName
        .Content = cls.Content
        .DataType = cls.DataType
        .DeRef = cls.DeRef
        .DoRef = cls.DoRef
        .VarType = cls.VarType
    End With
    
    Set CopyTACVar = clsNew
End Function

Public Function CreateTACVar( _
    ByVal udeType As TAC_VAR_TYPE, _
    Optional ByVal strVarID As String = "", _
    Optional ByVal varCont As Variant, _
    Optional ByVal DType As DATA_TYPE, _
    Optional ByVal blnDeRef As Boolean = False, _
    Optional ByVal blnDoRef As Boolean = False _
) As TACVar
    
    Dim clsVar As TACVar
    Set clsVar = New TACVar
    With clsVar
        .VarType = udeType
        .DataType = DType
        .VarName = strVarID
        .Content = varCont
        .DeRef = blnDeRef
        .DoRef = blnDoRef
    End With
    Set CreateTACVar = clsVar
End Function

Public Function CreateTAC( _
    ByVal cmd As TAC_COMMAND, _
    Optional ByVal Op As NODE_TYPE = NODE_NOT_DEFINED, _
    Optional ByVal lbl As String = "", _
    Optional ByVal asgn As TACVar = Nothing, _
    Optional ByVal clsLeft As TACVar = Nothing, _
    Optional ByVal clsRight As TACVar = Nothing _
) As TACStatement

    Dim clsTAC As TACStatement
    Set clsTAC = New TACStatement
    
    With clsTAC
        .Command = cmd
        .Operator = Op
        .JumpLabel = lbl
        Set .VarAssign = asgn
        Set .VarLeft = clsLeft
        Set .VarRight = clsRight
    End With
    
    Set CreateTAC = clsTAC
End Function

