VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum PARSER_ERROR_TYPE
    PARSER_ERR_UNKNOWN = -1
    PARSER_UNEXPECTED_TOKEN
    PARSER_NAME_AMBIGUOS
    PARSER_TYPE_UNKNOWN
    PARSER_INVALID_VALUE
    PARSER_INVALID_FUNCTION
    PARSER_WRONG_ARGUMENTS
    PARSER_UNKNOWN_NAME
    PARSER_VAR_EXPECTED
    PARSER_TYPE_MISMATCH
End Enum

Public Line     As Long
Public Position As Long
Public Number   As PARSER_ERROR_TYPE
Public Message  As String

Public Sub Init(ByVal lngLine As Long, _
                ByVal lngPos As Long, _
                ByVal udeNum As PARSER_ERROR_TYPE, _
                Optional ByVal strMsg As String = "")

    Line = lngLine
    Position = lngPos
    Number = udeNum
    
    If Len(strMsg) > 0 Then
        Message = strMsg
    Else
        Select Case udeNum
            Case PARSER_ERR_UNKNOWN:        Message = "Unbekannter Fehler"
            Case PARSER_UNEXPECTED_TOKEN:   Message = "Unerwartetes Symbol"
            Case PARSER_NAME_AMBIGUOS:      Message = "Zweideutiger Name"
            Case PARSER_TYPE_UNKNOWN:       Message = "Unbekannter Typ"
            Case PARSER_INVALID_VALUE:      Message = "Ungltiger Wert"
            Case PARSER_INVALID_FUNCTION:   Message = "Keine Funktion"
            Case PARSER_WRONG_ARGUMENTS:    Message = "Falsche/Ungengend Argumente"
            Case PARSER_UNKNOWN_NAME:       Message = "Unbekannter Name"
            Case PARSER_VAR_EXPECTED:       Message = "Variable erwartet"
            Case PARSER_TYPE_MISMATCH:      Message = "Inkompatible Typen"
        End Select
    End If
End Sub
