VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSPEcho"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IPlugin
Implements IPluginDSP

Private m_clsSess       As Session
Private m_sngEcho()     As Single
Private m_lngEchoPos    As Long
Private m_lngEchoPoints As Long
Private m_sngEchoLength As Single
Private m_sngAttenuation As Single
Private m_lngSamplerate As Long
Private m_lngChannels   As Long
Private m_blnEnabled    As Boolean

Public Property Get EchoAttenuation() As Single
    EchoAttenuation = m_sngAttenuation
End Property

Public Property Let EchoAttenuation(ByVal sngVal As Single)
    m_sngAttenuation = sngVal
    UpdateEcho
End Property

Public Property Get EchoLength() As Single
    EchoLength = m_sngEchoLength
End Property

Public Property Let EchoLength(ByVal sngVal As Single)
    m_sngEchoLength = sngVal
    UpdateEcho
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_blnEnabled
End Property

Public Property Let Enabled(ByVal blnVal As Boolean)
    m_blnEnabled = blnVal
End Property

Public Property Get MonoSession() As Session
    Set MonoSession = m_clsSess
End Property

Private Property Get IPlugin_Description() As String
    IPlugin_Description = "Fgt Audio Hall zu"
End Property

Private Property Get IPlugin_Name() As String
    IPlugin_Name = "Echo"
End Property

Private Property Get IPlugin_PluginType() As MonoPluginLib.PLUGIN_TYPE
    IPlugin_PluginType = PLUGIN_DSP
End Property

Private Sub IPluginDSP_FormatChanged(ByVal sr As Long, ByVal ch As Long)
    m_lngSamplerate = sr
    m_lngChannels = ch
    UpdateEcho
End Sub

Private Sub UpdateEcho()
    If m_lngSamplerate <> 0 Then
        m_lngEchoPoints = m_lngSamplerate / 1000 * m_sngEchoLength * m_lngChannels
        ReDim m_sngEcho(m_lngEchoPoints - 1) As Single
        m_lngEchoPos = 0
    End If
End Sub

Private Sub IPluginDSP_Init(ByVal mono As MonoPluginLib.Session)
    Set m_clsSess = mono
    m_blnEnabled = True
    m_sngEchoLength = 200
    m_sngAttenuation = 0.4
End Sub

Private Sub IPluginDSP_ProcessSamples(samples() As Single, ByVal lngOffset As Long, ByVal lngSamples As Long, lngReturned As Long)
    Dim i   As Long

    If m_blnEnabled Then
        For i = lngOffset To lngOffset + lngSamples - 1
            samples(i) = samples(i) + m_sngEcho(m_lngEchoPos)
            
            If samples(i) > 1 Then
                samples(i) = 1
            ElseIf samples(i) < -1 Then
                samples(i) = -1
            End If
            
            m_sngEcho(m_lngEchoPos) = samples(i) * m_sngAttenuation
            m_lngEchoPos = (m_lngEchoPos + 1) Mod m_lngEchoPoints
        Next
    End If
    
    lngReturned = lngSamples
End Sub

Private Sub IPluginDSP_ShowConfig()
    EchoSettings.LoadMe Me
End Sub

Private Sub IPluginDSP_Terminate()
    '
End Sub

Private Sub IPluginDSP_TrackChanged()
    '
End Sub
